using System;
using System.IO;

namespace WidReader.Data
{
    /// <summary>
    /// Reg̃f[^̊{
    /// </summary>
    public class BaseContent : FileIO
    {

        #region vpeB
        /// <summary>
        /// Reg
        /// </summary>
        protected byte MyKind
        {
            get { return mykind; }
            set { mykind = value; }
        }
        protected byte mykind;

        /// <summary>
        /// ʕf[^
        /// </summary>
        public string StringData
        {
            get { return str; }
            set { str = value; }
        }
        protected string str;
        /// <summary>
        /// ʕf[^̂Q
        /// </summary>
        public string StringData2
        {
            get { return str2; }
            set { str2 = value; }
        }
        protected string str2;

        /// <summary>
        /// ʐf[^ij
        /// </summary>
        public uint UInt
        {
            get { return ui; }
            set { ui = value; }
        }
        protected uint ui;

        /// <summary>
        /// Bytef[^
        /// </summary>
        public byte Byte1
        {
            get { return b; }
        }
        protected byte b;

        /// <summary>
        /// ʐf[^Q
        /// </summary>
        public int Int2
        {
            get { return i; }
            set { i = value; }
        }
        protected int i;

        /// <summary>
        /// Bytef[^Q
        /// </summary>
        public byte Byte2
        {
            get { return b2; }
        }
        protected byte b2;

        #endregion

        public BaseContent(byte kind) { mykind = kind; }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            switch (mykind)
            {
                // ^
                case 0x01:  // X^[gNReg (terminal)
                case 0x07:  // aflReg (standard)
                case 0x09:  // ʉReg (standard)
                case 0x0f:  // tOReg (data)
                case 0x11:  // Xebv򕪊Reg (data)
                case 0x29:  // XebvReg (data)
                case 0x2a:  // XebvReg (data)
                case 0x2b:  // tO]Reg (data)
                case 0x34:  // X^[gR[Reg (standard)
                case 0x39:  // I󕪊Reg (branch)
                case 0x3a:  // ItReg (get)
                case 0x3b:  // I폜Reg (lost)
                case 0x3c:  // SVbvReg (branch)
                case 0x3d:  // SVbvǉReg (get)
                case 0x3e:  // SVbv폜Reg (lost)
                case 0x41:  // tOReg (data)
                    str = r.ReadString();
                    break;

                // {Sa^
                case 0x2c:  // Xebv㉺Reg (data)
                case 0x12:  // XebvύXReg (data)
                    str = r.ReadString();
                    ui = r.ReadUInt32();
                    break;

                // {Sa{Pa^
                case 0x20:  // N[|擾Reg (get)
                case 0x27:  // N[|rReg (lost)
                case 0x19:  // N[|Reg (branch)
                case 0x48:  // XebvReg (data)
                    str = r.ReadString();
                    i = r.ReadInt32();
                    b = r.ReadByte();
                    break;

                // {Pa^
                case 0x10:  // tOReg (data)
                    str = r.ReadString();
                    b = r.ReadByte();
                    break;

                // {^
                case 0x42:  // XebvReg (data)
                case 0x43:  // tOReg (data)
                case 0x44:  // XebvrReg (data)
                case 0x45:  // tOrReg (data)
                    str = r.ReadString();
                    str2 = r.ReadString();
                    break;

                // Sa^
                case 0x0a:  // 󔒎ԃReg (standard)
                case 0x36:  // pbP[WR[Reg (standard)
                case 0x02:  // ogReg (terminal)
                case 0x05:  // GAړReg (terminal)
                case 0x35:  // pbP[WNReg (terminal)
                case 0x1a:  // LXgReg (get)
                case 0x21:  // LXgEReg (lost)
                case 0x13:  // LXgReg (branch)
                case 0x1d:  // Reg (get)
                case 0x24:  // rReg (lost)
                case 0x16:  // 񕪊Reg (branch)
                case 0x1f:  // Reg (get)
                case 0x26:  // Reg (lost)
                case 0x18:  // Reg (branch)
                case 0x0e:  // _Reg (utility)
                case 0x30:  // lReg (utility)
                    ui = r.ReadUInt32();
                    break;

                // Sa{Sa{Pa^
                case 0x1b:  // ACeReg (get)
                case 0x22:  // ACerReg (lost)
                case 0x14:  // ACeReg (branch)
                case 0x1c:  // Z\Reg (get)
                case 0x23:  // Z\rReg (lost)
                case 0x15:  // Z\Reg (branch)
                case 0x1e:  // bReg (get)
                case 0x25:  // brReg (lost)
                case 0x17:  // bReg (branch)
                    ui = r.ReadUInt32();
                    i = r.ReadInt32();
                    b = r.ReadByte();
                    break;

                // Pa^
                case 0x03:  // IReg (terminal)
                    b = r.ReadByte();
                    break;

                // Pa{Pa^
                case 0x0c:  // oIReg (utility)
                case 0x2f:  // ԔReg (utility)
                    b = r.ReadByte();
                    b2 = r.ReadByte();
                    break;

                // Pa{Sa^
                case 0x2e:  // xReg (utility)
                case 0x49:  // EhReg (utility)
                    b = r.ReadByte();
                    ui = r.ReadUInt32();
                    break;

                // Pa{Pa{^
                case 0x47:  // L[R[hReg (branch)
                    b = r.ReadByte();
                    b2 = r.ReadByte();
                    str = r.ReadString();
                    break;

                // f[^Ȃ^
                case 0x00:  // X^[gReg (terminal)
                case 0x33:  // ʒfReg (terminal)
                case 0x2d:  // ^[o߃Reg (standard)
                case 0x04:  // Q[I[o[Reg (terminal)
                case 0x31:  // p[eB[\Reg (visual)
                case 0x32:  // p[eB[BReg (visual)
                case 0x40:  // ʍč\zReg (visual)
                case 0x37:  // GAReg (utility)
                case 0x38:  // ogReg (utility)
                case 0x3F:  // ogReg (utility)
                    break;

                // ̑^
                case 0x0d:  //\͔Reg (utility)
                case 0x08:  // wiύXReg (standard)
                case 0x0b:  // ʃReg (standard)
                case 0x28:  // ZtReg (standard)
                case 0x06:  // bZ[WReg (standard)
                case 0x46:  // _IReg (utility)
                    //͋N肦Ȃ͂B
                    //ʃNXŃI[o[ChĂ
                    break;
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            switch (mykind)
            {
                // ^
                case 0x01:  // X^[gNReg (terminal)
                case 0x07:  // aflReg (standard)
                case 0x09:  // ʉReg (standard)
                case 0x0f:  // tOReg (data)
                case 0x11:  // Xebv򕪊Reg (data)
                case 0x29:  // XebvReg (data)
                case 0x2a:  // XebvReg (data)
                case 0x2b:  // tO]Reg (data)
                case 0x34:  // X^[gR[Reg (standard)
                case 0x39:  // I󕪊Reg (branch)
                case 0x3a:  // ItReg (get)
                case 0x3b:  // I폜Reg (lost)
                case 0x3c:  // SVbvReg (branch)
                case 0x3d:  // SVbvǉReg (get)
                case 0x3e:  // SVbv폜Reg (lost)
                case 0x41:  // tOReg (data)
                    w.Write(str);
                    break;

                // {Sa^
                case 0x2c:  // Xebv㉺Reg (data)
                case 0x12:  // XebvύXReg (data)
                    w.Write(str);
                    w.Write(ui);
                    break;

                // {Sa{Pa^
                case 0x20:  // N[|擾Reg (get)
                case 0x27:  // N[|rReg (lost)
                case 0x19:  // N[|Reg (branch)
                case 0x48:  // XebvReg (data)
                    w.Write(str);
                    w.Write(i);
                    w.Write(b);
                    break;

                // {Pa^
                case 0x10:  // tOPaReg (data)
                    w.Write(str);
                    w.Write(b);
                    break;

                // {^
                case 0x42:  // XebvReg (data)
                case 0x43:  // tOReg (data)
                case 0x44:  // XebvrReg (data)
                case 0x45:  // tOrReg (data)
                    w.Write(str);
                    w.Write(str2);
                    break;

                // Sa^
                case 0x0a:  // 󔒎ԃReg (standard)
                case 0x36:  // pbP[WR[Reg (standard)
                case 0x02:  // ogReg (terminal)
                case 0x05:  // GAړReg (terminal)
                case 0x35:  // pbP[WNReg (terminal)
                case 0x1a:  // LXgReg (get)
                case 0x21:  // LXgEReg (lost)
                case 0x13:  // LXgReg (branch)
                case 0x1d:  // Reg (get)
                case 0x24:  // rReg (lost)
                case 0x16:  // 񕪊Reg (branch)
                case 0x1f:  // Reg (get)
                case 0x26:  // Reg (lost)
                case 0x18:  // Reg (branch)
                case 0x0e:  // _Reg (utility)
                case 0x30:  // lReg (utility)
                    w.Write(ui);
                    break;

                // Sa{Sa{Pa^
                case 0x1b:  // ACeReg (get)
                case 0x22:  // ACerReg (lost)
                case 0x14:  // ACeReg (branch)
                case 0x1c:  // Z\Reg (get)
                case 0x23:  // Z\rReg (lost)
                case 0x15:  // Z\Reg (branch)
                case 0x1e:  // bReg (get)
                case 0x25:  // brReg (lost)
                case 0x17:  // bReg (branch)
                    w.Write(ui);
                    w.Write(i);
                    w.Write(b);
                    break;

                // Pa^
                case 0x03:  // IReg (terminal)
                    w.Write(b);
                    break;

                // Pa{Pa^
                case 0x0c:  // oIReg (utility)
                case 0x2f:  // ԔReg (utility)
                    w.Write(b);
                    w.Write(b2);
                    break;

                // Pa{Sa^
                case 0x2e:  // xReg (utility)
                case 0x49:  // EhReg (utility)
                    w.Write(b);
                    w.Write(ui);
                    break;

                // Pa{Pa{^
                case 0x47:  // L[R[hReg (branch)
                    w.Write(b);
                    w.Write(b2);
                    w.Write(str);
                    break;

                // f[^Ȃ^
                case 0x00:  // X^[gReg (terminal)
                case 0x33:  // ʒfReg (terminal)
                case 0x2d:  // ^[o߃Reg (standard)
                case 0x04:  // Q[I[o[Reg (terminal)
                case 0x31:  // p[eB[\Reg (visual)
                case 0x32:  // p[eB[BReg (visual)
                case 0x40:  // ʍč\zReg (visual)
                case 0x37:  // GAReg (utility)
                case 0x38:  // ogReg (utility)
                case 0x3F:  // ogReg (utility)
                    break;

                // ̑^
                case 0x0d:  //\͔Reg (utility)
                case 0x08:  // wiύXReg (standard)
                case 0x0b:  // ʃReg (standard)
                case 0x28:  // ZtReg (standard)
                case 0x06:  // bZ[WReg (standard)
                case 0x46:  // _IReg (utility)
                    //͋N肦Ȃ͂B
                    //ʃNXŃI[o[ChĂ
                    break;
            }
        }
        #endregion

    }//class BaseContent
}
