
using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{
    public class ContentData : FileIO
    {

        #region vpeB

        /// <summary>
        /// Reg
        /// </summary>
        public byte Kind
        {
            get { return contentKind; }
            set { contentKind = value; }
        }
        byte contentKind;

        /// <summary>
        /// ̃RegĂ΂ꂽ̑I
        /// </summary>
        public string Choice
        {
            get { return choice; }
            set { choice = value; }
        }
        string choice;

        /// <summary>
        /// ݂̃o[W
        /// </summary>
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        uint version;
        uint versionAndCount;
        uint count;

        /// <summary>
        /// qRegXg
        /// </summary>
        public List<ContentData> Children
        {
            get
            {
                return childList;
            }
        }
        List<ContentData> childList = new List<ContentData>();

        /// <summary>
        /// v5ŃRo[gɌ̃o[Wێ
        /// </summary>
        uint makeVersion;

        /// <summary>
        /// ̃Reg̎f[^
        /// </summary>
        public BaseContent Data
        {
            get { return contentData; }
            set { contentData = value; }
        }
        BaseContent contentData;

        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            contentKind = r.ReadByte();
            choice = r.ReadString();
            versionAndCount = r.ReadUInt32();
            version = versionAndCount / Const.VersionOffset;
            count = versionAndCount % Const.VersionOffset;
            
            for (; count > 0; count--)
            {
                ContentData content = new ContentData();
                content.Read(r);
                Children.Add(content);
            }

            if (Version == 5)
            {
                makeVersion = r.ReadUInt32();
            }

            contentData = NewContentData();
            contentData.Read(r);
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(contentKind);
            w.Write(choice);
            w.Write(((uint)Children.Count + version * Const.VersionOffset));
            foreach (ContentData con in Children)
                con.Write(w);
            if (Version == 5)
            {
                w.Write(makeVersion);
            }
            contentData.Write(w);
        }
        #endregion

        /// <summary>
        /// Reg̎ނɉBaseContent̎qNX̃CX^X𐶐܂B
        /// </summary>
        /// <returns>IuWFNg</returns>
        private BaseContent NewContentData()
        {
            switch (contentKind)
            {
                case 0x0d:  //\͔Reg
                    return new AbilityCheckContent();
                case 0x08:  // wiύXReg
                    return new ViewChangeContent();
                case 0x0b:  // ʃReg
                    if (Version == 0)
                    {
                        // ʃRegVersion0̂̂
                        // Version2`EffectData(EffectDataVersionNazo1^Cv)gp
                        return new EffectContent(2);
                    }
                    return new EffectContent(Version);
                case 0x28:  // ZtReg
                    return new SerifContent();
                case 0x06:  // bZ[WReg
                    return new MessageContent();
                case 0x46:  // _IReg
                    return new RandomSelectContent();
                default:
                    return new BaseContent(contentKind);
            }
        }
    }//class ContentData
}
