using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{
    /// <summary>
    /// ʃReg̃f[^
    /// </summary>
    public class EffectContent : BaseContent
    {
        #region tB[h
        uint version = 0;
        #endregion

        #region vpeB
        /// <summary>
        /// ʃx
        /// </summary>
        public int Level
        {
            get { return i; }
            set
            {
                if (value < Const.ContentMinLevel) i = Const.ContentMinLevel;
                else if (value > Const.ContentMaxLevel) i = Const.ContentMaxLevel;
                else i = value;
            }
        }

        /// <summary>
        /// ʑFex)@I
        /// </summary>
        public ʑ EffectAttribute
        {
            get { return (ʑ)attribute; }
            set { attribute = (byte)value; }
        }
        byte attribute;

        /// <summary>
        /// RFex)𑮐
        /// </summary>
        public R ResistAttribute
        {
            get { return (R)resist; }
            set { resist = (byte)value; }
        }
        byte resist;
        /// <summary>
        /// ΏہFex)p[eBS
        /// </summary>
        public Ώ Target
        {
            get { return (Ώ)b2; }
            set { b2 = (byte)value; }
        }
        /// <summary>
        /// C
        /// </summary>
        public int SuccessRate
        {
            get { return success; }
            set
            {
                if (value < Const.MinSuccessRate) success = Const.MinSuccessRate;
                else if (value > Const.MaxSuccessRate) success = Const.MaxSuccessRate;
                success = value;
            }
        }
        int success;
        /// <summary>
        /// ʉt@C
        /// </summary>
        public string SoundFile
        {
            get { return str; }
            set { str = value; }
        }
        /// <summary>
        /// J[hoʁFex)]
        /// </summary>
        public o VisualEffect
        {
            get { return (o)b; }
            set { b = (byte)value; }
        }
        public List<EffectData> Effects
        {
            get
            {
                return effectList;
            }
        }
        List<EffectData> effectList = new List<EffectData>();
        #endregion

        public EffectContent() : base(0x0b) { version = 4; }

        public EffectContent(uint ver) : base(0x0b) { version = ver; }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            Level = r.ReadInt32();
            attribute = r.ReadByte();
            resist = r.ReadByte();
            b2 = r.ReadByte();
            SuccessRate = r.ReadInt32();
            SoundFile = r.ReadString();
            b = r.ReadByte();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EffectData d = new EffectData(version);
                d.Read(r);
                Effects.Add(d);
            }
        }

        public override void Write(ShiftJisWriter w)
        {
            w.Write(Level);
            w.Write(attribute);
            w.Write(resist);
            w.Write(b2);
            w.Write(SuccessRate);
            w.Write(SoundFile);
            w.Write(b);
            w.Write(Effects.Count);
            foreach (EffectData d in Effects)
                d.Write(w);
        }

        #endregion

    }// class EffectContent
}
