using System;
using System.IO;
using System.Drawing;

namespace WidReader.Data
{
    public class ImageData : FileIO
    {
        private MemoryStream mstream;
        private int size;

        private Bitmap imageNotTransparent;
        private Bitmap image;

        private bool noSave = false;

        /// <summary>
        /// 摜f[^A͂܂ĂȂ
        /// </summary>
        public bool empty
        {
            get { return (size == 0) ? true : false; }
        }

        public Bitmap baseBitmap
        {
            get { return imageNotTransparent; }
            set 
            {
                imageNotTransparent = value;
                SetupSize();
                if (0 != size)
                {
                    image = (Bitmap)imageNotTransparent.Clone();
                    image.MakeTransparent(image.GetPixel(0, 0));
                }
                else
                {
                    image = null;
                }
            }
        }

        public Bitmap bitmap
        {
            get { return image; }
        }

        /// <summary>
        /// 摜f[^̃TCYOɂĖƂɂ(.wcp̏ꍇ)
        /// </summary>
        public void SetNoSave()
        {
            noSave = true;
        }

        /// <summary>
        /// 摜f[^݂̏ꍇ(̑gݍ݂̉摜̏ꍇ)
        /// </summary>
        public void SetSave()
        {
            noSave = false;
        }

        private void SetupSize()
        {
            if (imageNotTransparent == null)
            {
                // 摜Ȃꍇ肻
                size = 0;
                return;
            }

            string filename = "temp_"
             + DateTime.Now.ToString("yyyyMMdd_HHmmss_fff")
             + ".bmp";
            imageNotTransparent.Save(filename, System.Drawing.Imaging.ImageFormat.Bmp);
            FileInfo info = new FileInfo(filename);
            if (info.Length > int.MaxValue)
                throw new Exception();
            size = (int)info.Length;
            info.Delete();
            info = null;
        }

        public ImageData(Bitmap bmp)
        {
            imageNotTransparent = bmp;
            image = (Bitmap)imageNotTransparent.Clone();
            image.MakeTransparent(image.GetPixel(0, 0));
            SetupSize();
        }

        public ImageData()
        {
        }

        public override void Read(ShiftJisReader r)
        {
            size = r.ReadInt32();
            if (0 == size)
                return;
            byte[] buf = r.ReadBytes(size);
            mstream = new MemoryStream(size);
            mstream.Write(buf, 0, size);
            imageNotTransparent = new Bitmap(mstream);

            // SetupSize łƂ߂TCYReadInt32œǂݍ񂾃TCYႤƂ(2oCgق)B
            // ̂ߎTCYɃTCYu
            SetupSize();

            image = (Bitmap)imageNotTransparent.Clone();
            image.MakeTransparent(image.GetPixel(0, 0));
        }

        public override void Write(ShiftJisWriter w)
        {
            //ǂݍ񂾉摜Əމ摜ɈႤ
            SetupSize();

            if (!noSave)
            {
                w.Write(size);
                if (0 == size)
                    return;
            }
            else
            {
                w.Write(0);
                return;
            }

            string filename = "temp_"
             + DateTime.Now.ToString("yyyyMMdd_HHmmss_fff")
             + ".bmp";
            imageNotTransparent.Save(filename, System.Drawing.Imaging.ImageFormat.Bmp);
            
            byte[] buf = File.ReadAllBytes(filename);
            w.Write(buf, 0, size);
            File.Delete(filename);
            buf = null;
            

        }
    }
}
