using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{
    public class InnData : FileIO
    {
        public static readonly uint MaxCardSpeed = 8;
        public static readonly uint MaxViewSpeed = 8;
        public static readonly uint MaxMessageSpeed = 8;
        public static readonly uint DefCardSpeed = 4;
        public static readonly uint DefViewSpeed = 4;
        public static readonly uint DefMessageSpeed = 4;
        public static readonly uint MaxMessageBoardLight = 6;
        public static readonly uint DefMessageBoardLight = 3;
        public static readonly uint DefYadoMoney = 4000;

        public const string DATAVERSION_10 = "DATAVERSION_10";
        public const string DATAVERSION_11 = "DATAVERSION_11";

        public enum BackGroundAnimationEnum : byte
        { Ȃ, Xbh, tF[h, VF[u }

        public enum DispScenarioEnum : byte
        { BEIϔ\, B\, Sĕ\, Kx̂ }

        #region vpeB

        /// <summary>
        /// o[W
        /// </summary>
        public string Version
        {
            get { return versionString; }
            set { versionString = value; }
        }
        string versionString;

        /// <summary>
        /// fobOh
        /// </summary>
        public bool IsDebugInn
        {
            get { return (game_or_debug == 2); }

            set
            {
                if (value)
                {
                    game_or_debug = 2;
                }
                else
                {
                    game_or_debug = 1;
                }
            }
        }
        byte game_or_debug;

        /// <summary>
        /// fobOhɐݒ
        /// </summary>
        public void SetDebugInn()
        {
            game_or_debug = 2;
        }

        /// <summary>
        /// ʏhɐݒ
        /// </summary>
        public void SetNormalInn()
        {
            game_or_debug = 1;
        }

        /// <summary>
        /// IvṼJ[hEFCgBOōő
        /// </summary>
        public uint CardSpeed
        {
            get { return speed_card; }
            set
            {
                if (value > MaxCardSpeed)
                    speed_card = MaxCardSpeed;
                else if (value < 0)
                    speed_card = 0;
                else
                    speed_card = value;
            }
        }
        uint speed_card;

        /// <summary>
        /// IvV̔wi\EFCgBOōő
        /// </summary>
        public uint ViewSpeed
        {
            get { return speed_view; }
            set
            {
                if (value > MaxViewSpeed)
                    speed_view = MaxViewSpeed;
                else if (value < 0)
                    speed_view = 0;
                else
                    speed_view = value;
            }
        }
        uint speed_view;

        /// <summary>
        /// IvṼbZ[W\EFCgBOōő
        /// </summary>
        public uint MessageSpeed
        {
            get { return speed_message; }
            set
            {
                if (value > MaxMessageSpeed)
                    speed_message = MaxMessageSpeed;
                else if (value < 0)
                    speed_message = 0;
                else
                    speed_message = value;
            }
        }
        uint speed_message;

        public bool BgmON
        {
            get { return (on_bgm == 1); }
            set { on_bgm = (byte)(value ? 1 : 0); }
        }
        byte on_bgm;

        public bool SoundON
        {
            get { return (on_sound == 1); }
            set { on_sound = (byte)(value ? 1 : 0); }
        }
        byte on_sound;

        public bool ReduceCardCorrectionON
        {
            get { return (on_smallcard == 1); }
            set { on_smallcard = (byte)(value ? 1 : 0); }
        }
        byte on_smallcard;

        public bool MagnifyCardCorrectionON
        {
            get { return (on_largecard == 1); }
            set { on_largecard = (byte)(value ? 1 : 0); }
        }
        byte on_largecard;

        #region ̑
        public bool AutoLoadON
        {
            get { return (on_autoload == 1); }
            set { on_autoload = (byte)(value ? 1 : 0); }
        }
        byte on_autoload;

        public bool BackGroundCancelON
        {
            get { return (on_cancellback == 1); }
            set { on_cancellback = (byte)(value ? 1 : 0); }
        }
        byte on_cancellback;

        public bool MoneyEffectON
        {
            get { return (on_moneyeffect == 1); }
            set { on_moneyeffect = (byte)(value ? 1 : 0); }
        }
        byte on_moneyeffect;

        public bool SkipEventByRightClickON
        {
            get { return (on_eventjump == 1); }
            set { on_eventjump = (byte)(value ? 1 : 0); }
        }
        byte on_eventjump;

        public bool KeepMaxLevelON
        {
            get { return (on_keepmaxlevel == 1); }
            set { on_keepmaxlevel = (byte)(value ? 1 : 0); }
        }
        byte on_keepmaxlevel;

        /// <summary>
        /// I[hł̔wi
        /// </summary>
        public bool BackGroundEffect
        {
            get { return (backGroundEffect == 1); }
            set { backGroundEffect = (byte)(value ? 1 : 0); }
        }
        byte backGroundEffect = 0;
        #endregion

        /// <summary>
        /// ViI\I
        /// BEIς\ȂFOAB\ȂFP
        /// SāFQAx݂̂R
        /// </summary>
        public DispScenarioEnum DispScenarioEffect
        {
            get { return (DispScenarioEnum)on_backnet; }
            set { on_backnet = (byte)value; }
        }
        byte on_backnet;

        /// <summary>
        /// bZ[W{[h̖邳BOłÂ
        /// </summary>
        public uint MessageLight
        {
            get { return messageLight; }
            set
            {
                if (value > MaxMessageBoardLight)
                    messageLight = MaxMessageBoardLight;
                else if (value < 0)
                    messageLight = 0;
                else
                    messageLight = value;
            }
        }
        uint messageLight;

        /// <summary>
        /// tHgtO
        /// </summary>
        public bool DecoFontON
        {
            get { return (on_decoFont == 1); }
            set { on_decoFont = (byte)(value ? 1 : 0); }
        }
        byte on_decoFont;

        /// <summary>
        /// wiAj[V
        /// </summary>
        public BackGroundAnimationEnum BackGroundAnimation
        {
            get { return (BackGroundAnimationEnum)backanime; }
            set { backanime = (byte)value; }
        }
        byte backanime;

        /// <summary>
        /// Iς݃ViIXgB蓖ĂȂ犄蓖Ăs
        /// </summary>
        public StringCollection FinishScenarios
        {
            get
            {
                return finishScenarioStringList;
            }
        }
        StringCollection finishScenarioStringList = new StringCollection();

        /// <summary>
        /// is̃ViIXgB蓖ĂȂ犄蓖Ăs
        /// </summary>
        public StringCollection ProgressScenarios
        {
            get
            {
                return progressScenarioStringList;
            }
        }
        StringCollection progressScenarioStringList = new StringCollection();

        /// <summary>
        /// SVbvXgB蓖ĂȂ犄蓖Ăs
        /// </summary>
        public StringCollection Gossips
        {
            get
            {
                return gossipStringList;
            }
        }
        StringCollection gossipStringList = new StringCollection();

        /// <summary>
        /// h̎݃t@CJ[hXgB蓖ĂȂ犄蓖Ăs
        /// </summary>
        public List<RenamedCardData> BankBoxCards
        {
            get
            {
                return yadoRenamedCardList;
            }
            set
            {
                yadoRenamedCardList = value;
            }
        }
        List<RenamedCardData> yadoRenamedCardList = new List<RenamedCardData>();

        /// <summary>
        /// h̃CfbNXJ[hXgB蓖ĂȂ犄蓖Ăs
        /// </summary>
        public List<CardIndexData> CardIndexDatas
        {
            get
            {
                return yadoIndexedCardList;
            }
            set
            {
                yadoIndexedCardList = value;
            }
        }
        List<CardIndexData> yadoIndexedCardList = new List<CardIndexData>();

        /// <summary>
        /// hz
        /// </summary>
        public uint YadoMoney
        {
            get { return yadoMoney; }
            set
            {
                if (value > Const.MaxMoneyValue)
                    yadoMoney = Const.MaxMoneyValue;
                else if (value < 0)
                    yadoMoney = 0;
                else yadoMoney = value;
            }
        }
        uint yadoMoney;

        /// <summary>
        /// I[g[hΏۃp[eB[
        /// </summary>
        public string AutoLoadParty
        {
            get { return loadPartyName; }
            set { loadPartyName = value; }
        }
        string loadPartyName;

        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            versionString = r.ReadString();
            game_or_debug = r.ReadByte();

            // iʁjx
            speed_card = r.ReadUInt32();
            speed_view = r.ReadUInt32();
            speed_message = r.ReadUInt32();

            // 
            // iI[fBIjBGM炷`FbN
            on_bgm = r.ReadByte();
            // iI[fBIjʉ炷`FbN
            on_sound = r.ReadByte();

            // J[h̉摜C
            // iʁjkJ[h
            on_smallcard = r.ReadByte();
            // iʁjgJ[h
            on_largecard = r.ReadByte();

            // ̑iVXeEʁj
            // iVXejp[eB̃I[g[h
            on_autoload = r.ReadByte();
            // iVXejwiNbNɂLZ
            on_cancellback = r.ReadByte();
            // iʁjύX̎o
            on_moneyeffect = r.ReadByte();
            // iVXejwiNbNɂCxgԂ̃Wv
            on_eventjump = r.ReadByte();
            // iVXejxőlɈێ
            on_keepmaxlevel = r.ReadByte();
            if (versionString == DATAVERSION_11)
            {
                // iʁjI[hł̔wi
                backGroundEffect = r.ReadByte();
            }

            // iVXej\̕\
            //BEIς\ȂFOAB\ȂFP
            //ASāFQAx݂̂R
            on_backnet = r.ReadByte();

            // iʁjbZ[W{[h
            messageLight = r.ReadUInt32();
            on_decoFont = r.ReadByte();

            // iʁjwi̐؂ւ
            backanime = r.ReadByte();

            //iIEisjViIXgAhSVbv
            finishScenarioStringList = r.ReadStringCollection();
            progressScenarioStringList = r.ReadStringCollection();
            gossipStringList = r.ReadStringCollection();

            // J[h
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                RenamedCardData d = new RenamedCardData();
                d.Read(r);
                BankBoxCards.Add(d);
            }
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CardIndexData d = new CardIndexData();
                d.Read(r);
                CardIndexDatas.Add(d);
            }

            // h
            yadoMoney = r.ReadUInt32();
            // I𒆂̃p[eB[
            loadPartyName = r.ReadString();
        }

        public override void Write(ShiftJisWriter w)
        {
            w.Write(versionString);
            w.Write(game_or_debug);

            // x
            w.Write(speed_card);
            w.Write(speed_view);
            w.Write(speed_message);

            // 
            w.Write(on_bgm);
            w.Write(on_sound);

            // J[h̉摜C
            w.Write(on_smallcard);
            w.Write(on_largecard);

            // ̑
            w.Write(on_autoload);
            w.Write(on_cancellback);
            w.Write(on_moneyeffect);
            w.Write(on_eventjump);
            w.Write(on_keepmaxlevel);
            if (versionString == DATAVERSION_11)
            {
                w.Write(backGroundEffect);
            }

            // ViI\I
            w.Write(on_backnet);

            // bZ[W{[h
            w.Write(messageLight);
            w.Write(on_decoFont);

            // wiAj[V
            w.Write(backanime);

            w.Write(FinishScenarios);
            w.Write(ProgressScenarios);
            w.Write(Gossips);
            
            w.Write(BankBoxCards.Count);
            foreach (RenamedCardData d in BankBoxCards)
                d.Write(w);
            w.Write(CardIndexDatas.Count);
            foreach (CardIndexData d in CardIndexDatas)
                d.Write(w);
            w.Write(yadoMoney);
            w.Write(loadPartyName);
        }

        #endregion
    }
}
