/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
/**
 * ViIsf[^
 */
using System;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace WidReader.Data
{

    public class ScenarioData : FileIO
    {
        #region vpeB

        short nazo1_0;
        
        public string ScenarioFolder
        {
            get { return folderpath; }
            set { folderpath = value; }
        }
        string folderpath;
        public uint AreaNumber
        {
            get { return areaNumber; }
            set { areaNumber = value; }
        }
        uint areaNumber;
        public StringCollection StepValues
        {
            get
            {
                return stepValueStringList;
            }
            set
            {
                stepValueStringList = value;
            }
        }
        StringCollection stepValueStringList = new StringCollection();
        public StringCollection FlagValues
        {
            get
            {
                return flagValueStringList;
            }
            set
            {
                flagValueStringList = value;
            }
        }
        StringCollection flagValueStringList = new StringCollection();
        public StringCollection PossessNpcCards
        {
            get
            {
                return npcCardStringList;
            }
            set
            {
                npcCardStringList = value;
            }
        }
        StringCollection npcCardStringList = new StringCollection();
        public StringCollection PossessInfoCards
        {
            get
            {
                return infoCardStringList;
            }
            set
            {
                infoCardStringList = value;
            }
        }
        StringCollection infoCardStringList = new StringCollection();
        public string BGMFile
        {
            get { return bgmFilename; }
            set { bgmFilename = value; }
        }
        string bgmFilename;
        public List<CellData> Cells
        {
            get
            {
                return cellList;
            }
            set
            {
                if (value != null)
                    cellList = value;
            }
        }
        List<CellData> cellList = new List<CellData>();
        #endregion

        #region RXgN^
        // is̃p[eB[̃ViI󋵂
        public ScenarioData(){ }

        public ScenarioData(SummaryData summary) 
        {
            foreach (StepIndexData step in summary.Steps)
            {
                StepValues.Add(step.StepName + "=" + step.InitialValue);
            }
            foreach (FlagIndexData flag in summary.Flags)
            {
                FlagValues.Add(flag.FlagName + "=" + flag.InitialValue);
            }
        }
        #endregion

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            nazo1_0 = r.ReadInt16();
            folderpath = r.ReadString();
            areaNumber = r.ReadUInt32();
            stepValueStringList = r.ReadStringCollection();
            flagValueStringList = r.ReadStringCollection();
            npcCardStringList = r.ReadStringCollection();
            infoCardStringList = r.ReadStringCollection();
            bgmFilename = r.ReadString();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData d = new CellData();
                d.Read(r);
                Cells.Add(d);
            }
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(nazo1_0);
            w.Write(folderpath);
            w.Write(areaNumber);
            w.Write(StepValues);
            w.Write(FlagValues);
            w.Write(PossessNpcCards);
            w.Write(PossessInfoCards);
            w.Write(bgmFilename);
            w.Write(Cells.Count);
            foreach (CellData d in Cells)
                d.Write(w);
        }
        #endregion

        #region \bh
        public void SetStep(string name, int value)
        {
            for (int i = 0; i < this.StepValues.Count;i++ )
            {
                if (this.StepValues[i].Split('=')[0].Equals(name))
                {
                    this.StepValues[i]
                        = name + "=" + value;
                    return;
                }
            }

            this.StepValues.Add(name + "=" + value);
        }

        public void SetFlag(string name, int value)
        {
            for (int i = 0; i < this.FlagValues.Count;i++ )
            {
                if (this.FlagValues[i].Split('=')[0].Equals(name))
                {
                    this.FlagValues[i]
                        = name + "=" + value;
                    return;
                }
            }

            this.FlagValues.Add(name + "=" + value);
        }

        public void SetInfo(string name)
        {

            foreach (string str in this.PossessInfoCards)
            {
                if (str.Equals(name))
                {
                    return;
                }
            }

            this.PossessInfoCards.Add(name);
        }
        #endregion

    }//class ScenarioData
}
