using System;
using System.Collections.Specialized;
using System.Collections.Generic;

namespace WidReader.Data
{
    public class StepIndexData : FileIO
    {
        #region vpeB
        public string StepName
        {
            get { return name; }
            set { name = value; }
        }
        string name;
        public uint InitialValue
        {
            get { return initial; }
            set { initial = value; }
        }
        uint initial;
        public string[] ValueStrings
        {
            get { return values; }
        }
        string[] values = new string[10];
        #endregion

        public StepIndexData() {  }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            name = r.ReadString();
            initial = r.ReadUInt32();
            for (int k = 0; k <= 9; k++)
                values[k] = r.ReadString();
        }
        public override void Write(ShiftJisWriter w)
        {
            w.Write(name);
            w.Write(initial);
            foreach (string st in values)
                w.Write(st);
        }
        #endregion
    }
}
