using System;
using System.Collections.Specialized;
using System.Collections.Generic;

namespace WidReader.Data
{
    /// <summary>
    /// ViIT}
    /// </summary>
    public class SummaryData : FileIO
    {

        #region vpeB
        
        /// <summary>
        /// 摜
        /// </summary>
        public ImageData Image
        {
            get { return image; }
        }
        ImageData image = new ImageData();

        /// <summary>
        /// ViI
        /// </summary>
        public string ScenarioName
        {
            get { return scenario; }
            set { scenario = value; }
        }
        string scenario;

        /// <summary>
        /// ViI
        /// </summary>
        public string ScenarioExpression
        {
            get { return expression; }
            set { expression = value; }
        }
        string expression;

        /// <summary>
        /// Җ
        /// </summary>
        public string Author
        {
            get { return author; }
            set { author = value; }
        }
        string author;

        /// <summary>
        /// KvN[|Xg
        /// </summary>
        public StringCollection NeedCoupons
        {
            get
            {
                return needCoupon;
            }
        }
        StringCollection needCoupon = new StringCollection();

        /// <summary>
        /// KvN[|
        /// </summary>
        public uint NeedCouponCount
        {
            get { return needCouponCount; }
            set { needCouponCount = value; }
        }
        uint needCouponCount;

        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return areaANDversion / Const.VersionOffset; }
            set { areaANDversion = AreaNumber + value * Const.VersionOffset; }
        }
        uint areaANDversion;
        /// <summary>
        /// JnGAԍ
        /// </summary>
        public uint AreaNumber
        {
            get { return areaANDversion % Const.VersionOffset; }
            set { areaANDversion = value + Version * Const.VersionOffset; }
        }

        /// <summary>
        /// Xebv
        /// </summary>
        public List<StepIndexData> Steps
        {
            get
            {
                return stepList;
            }
        }
        List<StepIndexData> stepList = new List<StepIndexData>();

        /// <summary>
        /// tO
        /// </summary>
        public List<FlagIndexData> Flags
        {
            get
            {
                return flagList;
            }
        }
        List<FlagIndexData> flagList = new List<FlagIndexData>();

        //̍
        int nazo0;

        /// <summary>
        /// Œ჌x
        /// </summary>
        public uint LevelLow
        {
            get { return levelLow; }
            set { levelLow = value; }
        }
        uint levelLow;

        /// <summary>
        /// ő僌x
        /// </summary>
        public uint LevelHigh
        {
            get { return levelHigh; }
            set { levelHigh = value; }
        }
        uint levelHigh;

        #endregion

        public SummaryData() { }

        public SummaryData(string fullpath):base(fullpath) { }

        #region [hCg
        public override void Read(ShiftJisReader r)
        {
            image.Read(r);
            scenario = r.ReadString();
            expression = r.ReadStringCRLF();
            author = r.ReadString();
            needCoupon = r.ReadStringCollection();
            needCouponCount = r.ReadUInt32();
            areaANDversion = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                StepIndexData step = new StepIndexData();
                step.Read(r);
                Steps.Add(step);
            }
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                FlagIndexData flag = new FlagIndexData();
                flag.Read(r);
                Flags.Add(flag);
            }

            nazo0 = r.ReadInt32();

            if (!r.IsEOF())
            {
                levelLow = r.ReadUInt32();
                levelHigh = r.ReadUInt32();
            }
  
        }

        public override void Write(ShiftJisWriter w)
        {
            image.Write(w);
            w.Write(scenario);
            w.WriteCRLF(expression);
            w.Write(author);
            w.Write(needCoupon);
            w.Write(needCouponCount);
            w.Write(areaANDversion);
            w.Write(Steps.Count);
            foreach (StepIndexData d in Steps)
                d.Write(w);
            w.Write(Flags.Count);
            foreach (FlagIndexData d in Flags)
                d.Write(w);
            w.Write(nazo0);
            w.Write(levelLow);
            w.Write(levelHigh);
        }

        #endregion
    }
}
