using System;
using System.IO;
using System.Collections.Generic;

namespace WidReader.Data
{
    /// <summary>
    /// XLAACeAb̃t@Cf[^
    /// </summary>
    public class WidCard : FileIO
    {
        #region vpeB
        /// <summary>
        /// f[^o[WTi܂h̃f[^jł́A
        /// ̕OɂȂĂ肷B
        /// </summary>
        public WidIDtype WidID
        {
            get
            {
                if (fixCardType)
                {
                    return cardType;
                }

                if (Version > 2)
                {
                    return (WidIDtype)widid;
                }
                else
                {
                    switch((WidIDtypeV2)widid){
                        case WidIDtypeV2.ACe:
                            return WidIDtype.ACe;
                        case WidIDtypeV2.XL:
                            return WidIDtype.XL;
                        case WidIDtypeV2.b:
                            return WidIDtype.b;
                        default:
                            throw new Exception();
                    }
                }
            }
            set { widid = (byte)value; }
        }
        byte widid;
        
        public bool FixCardType 
        {
            get { return fixCardType; }
            set { fixCardType = value; }
        }
        bool fixCardType = false;
        WidIDtype cardType = WidIDtype.XL;
        /// <summary>
        /// 摜
        /// </summary>
        public ImageData Image
        {
            get { return image; }
            set { image = value; }
        }
        ImageData image = new ImageData();
        /// <summary>
        /// J[h̖O
        /// </summary>
        public string CardName
        {
            get { return name; }
            set { name = value; }
        }
        string name;
        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return numberANDversion 
                @@/ Const.VersionOffset; }
            set { numberANDversion 
                = FileNumber + value * Const.VersionOffset; }
            }
            uint numberANDversion;
        /// <summary>
        /// J[hԍ
        /// </summary>
        public uint FileNumber
        {
            get { return numberANDversion
                @@% Const.VersionOffset; }
            set { numberANDversion 
                = value + Version * Const.VersionOffset; }
        }
        /// <summary>
        /// J[h
        /// </summary>
        public string Expression
        {
            get { return expression; }
            set { expression = value; }
        }
        string expression;
        /// <summary>
        /// g̓K
        /// </summary>
        public g̓Ivf BodyFacter
        {
            get { return (g̓Ivf)proper_body; }
            set { proper_body = (uint)value; }
        }
        uint proper_body;
        /// <summary>
        /// _K
        /// </summary>
        public _Ivf MindFacter
        {
            get { return (_Ivf)proper_mind; }
            set { proper_mind = (int)value; }
        }
        int proper_mind = 1;
        /// <summary>
        /// KviَɎgpsj
        /// </summary>
        public bool NeedCast
        {
            get { return !(voice == 0); }
            set { voice = (byte)(value ? 1 : 0); }
        }
        byte voice;
        /// <summary>
        /// ʔ͈(ex ṔAS
        /// </summary>
        public ʔ͈ Range
        {
            get { return (ʔ͈)range; }
            set { range = (byte)value; }
        }
        byte range;
        /// <summary>
        /// ʖڕW(Ex.GA
        /// </summary>
        public ʖڕW Target
        {
            get { return (ʖڕW)target; }
            set { target = (byte)value; }
        }
        byte target;
        /// <summary>
        /// ʑFex)@I
        /// </summary>
        public ʑ EffectAttribute
        {
            get { return (ʑ)attribute; }
            set { attribute = (byte)value; }
        }
        byte attribute;
        /// <summary>
        /// RFex)𑮐
        /// </summary>
        public R ResistAttribute
        {
            get { return (R)resist; }
            set { resist = (byte)value; }
        }
        byte resist;
        /// <summary>
        /// C
        /// </summary>
        public int SuccessRate
        {
            get { return success; }
            set
            {
                if (value < Const.MinSuccessRate) 
                    success = Const.MinSuccessRate;
                else if (value > Const.MaxSuccessRate) 
                    success = Const.MaxSuccessRate;
                success = value;
            }
        }
        int success;
        /// <summary>
        /// J[hoʁFex)]
        /// </summary>
        public o VisualEffect
        {
            get { return (o)visual; }
            set { visual = (byte)value; }
        }
        byte visual;

        /// <summary>
        /// ʃXg
        /// </summary>
        public List<EffectData> Effects
        {
            get
            {
                return effectList;
            }
        }
        List<EffectData> effectList = new List<EffectData>();
        /// <summary>
        /// gp͏Cib͏Lj
        /// </summary>
        public int AvoidModifyUsing
        {
            get { return add_avoid; }
            set
            {
                if (value < Const.MinModifyMount) 
                    add_avoid = Const.MinModifyMount;
                else if (value > Const.MaxModifyMount) 
                    add_avoid = Const.MaxModifyMount;
                add_avoid = value;
            }
        }
        int add_avoid;
        /// <summary>
        /// gpR͏Cib͏Lj
        /// </summary>
        public int ResistModifyUsing
        {
            get { return add_resist; }
            set
            {
                if (value < Const.MinModifyMount) 
                    add_resist = Const.MinModifyMount;
                else if (value > Const.MaxModifyMount) 
                    add_resist = Const.MaxModifyMount;
                add_resist = value;
            }
        }
        int add_resist;
        /// <summary>
        /// gph͏Cib͏Lj
        /// </summary>
        public int ArmorModifyUsing
        {
            get { return add_armor; }
            set
            {
                if (value < Const.MinModifyMount) 
                    add_armor = Const.MinModifyMount;
                else if (value > Const.MaxModifyMount) 
                    add_armor = Const.MaxModifyMount;
                add_armor = value;
            }
        }
        int add_armor;
        /// <summary>
        /// ʉ
        /// </summary>
        public string SoundOnUsing
        {
            get { return wav1; }
            set { wav1 = value; }
        }
        string wav1;
        /// <summary>
        /// ʎʉ
        /// </summary>
        public string SoundOnEffect
        {
            get { return wav2; }
            set { wav2 = value; }
        }
        string wav2;
        /// <summary>
        /// L[R[hzBT܂Łi܂S܂ŁjłB
        /// </summary>
        public string[] KeyCode
        {
            get { return keyCode; }
        }
        string[] keyCode = new string[5];

        /// <summary>
        /// 󏭓x
        /// </summary>
        public 󏭓x Rarity
        {
            get { return (󏭓x)(rarityANDfix % Const.CardFixMarkOffset); }
            set { rarityANDfix = (byte)((byte)value 
                + (FixPossession ? (byte)0 : Const.CardFixMarkOffset)); }
        }
        byte rarityANDfix;
        /// <summary>
        /// miF9ΏۊOj({F9Ώۂ̎ɒlAmł0)
        /// </summary>
        public bool FixPossession
        {
            get { return (rarityANDfix / Const.CardFixMarkOffset == 0); }
            set { rarityANDfix = (byte)((byte)Rarity 
                + (value ? (byte)0 : Const.CardFixMarkOffset)); }
        }

        /// <summary>
        /// 쐬ViI
        /// </summary>
        public string ScenarioName
        {
            get { return scenarioName; }
            set { scenarioName = value; }
        }
        string scenarioName;
        /// <summary>
        /// Җ
        /// </summary>
        public string AuthorName
        {
            get { return author; }
            set { author = value; }
        }
        string author;
        /// <summary>
        /// gpCxg
        /// </summary>
        public List<EventData> Events
        {
            get
            {
                return eventList;
            }
        }
        List<EventData> eventList = new List<EventData>();
        /// <summary>
        /// LԂŃz[hĂ邩
        /// </summary>
        public bool HoldCard
        {
            get { return !(hold == 0); }
            set { hold = (byte)(value ? 1 : 0); }
        }
        byte hold;

        /// <summary>
        /// ̃o[Wio[WTŃf[^Ro[gɐݒj
        /// </summary>
        uint makeVersion;
        
        /// <summary>
        /// Z\FJ[hx
        /// </summary>
        public uint Level
        {
            get { return levelORcount; }
            set { levelORcount = value; }
        }
        uint levelORcount;
        /// <summary>
        /// ACeAbFc
        /// </summary>
        public uint ItemRemainUseCount
        {
            get { return levelORcount; }
            set { levelORcount = value; }
        }

        /// <summary>
        /// ibiitє\)
        /// ({͈ꎞbiꎞtє\)̎rbgj
        /// </summary>
        public bool HutaiBeast
        {
            get { return (hutai == 0); }
            set { hutai = (byte)(!value ? 1 : 0); }
        }
        byte hutai;

        /// <summary>
        /// XLFc
        /// </summary>
        public uint SkillRemainUseCount
        {
            get { return skilluseORinitcount; }
            set { skilluseORinitcount = value; }
        }
        uint skilluseORinitcount;
        /// <summary>
        /// ACeF̎gp
        /// </summary>
        public uint ItemInitialUseCount
        {
            get { return skilluseORinitcount; }
            set { skilluseORinitcount = value; }
        }

        /// <summary>
        /// ACeFi
        /// </summary>
        public uint ItemPrice
        {
            get { return price; }
            set
            {
                if (value > Const.ItemPriceMax) 
                    price = Const.ItemPriceMax;
                else price = value;
            }
        }
        uint price;
        /// <summary>
        /// L͏CiACê݁BbAvoidModifyUsinggpj
        /// </summary>
        public int PossessModifyAvoid
        {
            get { return possess_avoid; }
            set
            {
                if (value < Const.MinModifyMount) 
                    possess_avoid = Const.MinModifyMount;
                else if (value > Const.MaxModifyMount) 
                    possess_avoid = Const.MaxModifyMount;
                possess_avoid = value;
            }
        }
        int possess_avoid;
        /// <summary>
        /// LR͏CiACê݁BbResistModifyUsinggpj
        /// </summary>
        public int PossessModifyResist
        {
            get { return possess_resist; }
            set
            {
                if (value < Const.MinModifyMount) 
                    possess_resist = Const.MinModifyMount;
                else if (value > Const.MaxModifyMount) 
                    possess_resist = Const.MaxModifyMount;
                possess_resist = value;
            }
        }
        int possess_resist;
        /// <summary>
        /// Lh͏CiACê݁BbArmorModifyUsinggpj
        /// </summary>
        public int PossessModifyArmor
        {
            get { return possess_armor; }
            set
            {
                if (value < Const.MinModifyMount) 
                    possess_armor = Const.MinModifyMount;
                else if (value > Const.MaxModifyMount) 
                    possess_armor = Const.MaxModifyMount;
                possess_armor = value;
            }
        }
        int possess_armor;

        /// <summary>
        /// TCNǂ
        /// </summary>
        public bool IsRecycle
        {
            get
            {
                for (int i = 0; i < 5; i++)
                    if (this.KeyCode[i] == "TCN")
                        return true;
                return false;
            }
        }

        #endregion

        #region RXgN^

        /// <summary>
        /// Ƃ肠ImageقRXgN^
        /// </summary>
        public WidCard()
        {
        }

        public WidCard(WidIDtype id)
        {
            SetCardType(id);
        }

        private void SetCardType(WidIDtype id)
        {
            cardType = id;
            fixCardType = true;
        }

        /// <summary>
        /// WidIDtypet@Cݒ肵ĕto[W
        /// </summary>
        /// <param name="fullpath"></param>
        public WidCard(string fullpath)
        {
            this.FullPath = fullpath;

            using (ShiftJisReader r
                = new ShiftJisReader(File.OpenRead(fullpath)))
            {
                Read(r);
            }
        }

        /// <summary>
        /// IuWFNg̃Rs[ԂBQƌ^͋LB
        /// </summary>
        /// <param name="src"></param>
        public WidCard(WidCard src)
        {
            widid = src.widid;
            image = src.image;
            name = src.name;
            numberANDversion = src.numberANDversion;
            expression = src.expression;
            proper_body = src.proper_body;
            proper_mind = src.proper_mind;
            voice = src.voice;
            range = src.range;
            target = src.target;
            attribute = src.attribute;
            resist = src.resist;
            success = src.success;
            visual = src.visual;
            effectList = src.effectList;
            add_avoid = src.add_avoid;
            add_resist = src.add_resist;
            add_armor = src.add_armor;
            wav1 = src.wav1;
            wav2 = src.wav2;
            keyCode = src.keyCode;
            rarityANDfix = src.rarityANDfix;
            scenarioName = src.scenarioName;
            author = src.author;
            eventList = src.eventList;
            hold = src.hold;
            makeVersion = src.makeVersion;
            levelORcount = src.levelORcount;
            skilluseORinitcount = src.skilluseORinitcount;
            hutai = src.hutai;
            price = src.price;
            possess_avoid = src.possess_avoid;
            possess_resist = src.possess_resist;
            possess_armor = src.possess_armor;
        }

        #endregion

        #region [hCg

        public override void Read(ShiftJisReader r)
        {
            //WidID̓o[W2ȉ3ȍ~ňႤ
            byte b = r.ReadByte();

            if (b != 0)
                widid = b;

            image.Read(r);
            name = r.ReadString();
            numberANDversion = r.ReadUInt32();
            expression = r.ReadString();
            proper_body = r.ReadUInt32();
            proper_mind = r.ReadInt32();
            voice = r.ReadByte();
            range = r.ReadByte();
            target = r.ReadByte();
            attribute = r.ReadByte();
            resist = r.ReadByte();
            success = r.ReadInt32();
            visual = r.ReadByte();
            uint count = r.ReadUInt32();
            EffectData ef = null;
            for (; count > 0; count--)
            {
                ef = new EffectData(Version);
                ef.Read(r);
                Effects.Add(ef);
            }

            add_avoid = r.ReadInt32();
            add_resist = r.ReadInt32();
            add_armor = r.ReadInt32();

            wav1 = r.ReadString();
            wav2 = r.ReadString();
            keyCode[0] = r.ReadString();
            keyCode[1] = r.ReadString();
            keyCode[2] = r.ReadString();
            keyCode[3] = r.ReadString();
            keyCode[4] = r.ReadString();
            
            if (Version >= 2)
            {
                //󏭓xVersion2
                rarityANDfix = r.ReadByte();
            }

            if (Version > 2)
            {

                //Version2(1.15)ł
                //ViIAҖ̓J[hɏoȂA
                //gpCxgB
                //z[h
                //WidIDقȂ

                scenarioName = r.ReadString();
                author = r.ReadString();
                count = r.ReadUInt32();
                EventData ev = null;
                for (; count > 0; count--)
                {
                    ev = new EventData(false);
                    ev.Read(r);
                    Events.Add(ev);
                }

                // z[h
                hold = r.ReadByte();

                // v5ɃRo[gꂽƂɌ̃o[W
                if (Version == 5)
                    makeVersion = r.ReadUInt32();

            }

            levelORcount = r.ReadUInt32();

            if (WidID == WidIDtype.b)
            {
                if (Version == 5)
                    hutai = r.ReadByte();
                return;
            }


            skilluseORinitcount = r.ReadUInt32();

            if (WidID == WidIDtype.XL)
                return;

            price = r.ReadUInt32();
            possess_avoid = r.ReadInt32();
            possess_resist = r.ReadInt32();
            possess_armor = r.ReadInt32();

        }

        public override void Write(ShiftJisWriter w)
        {
            w.Write(widid);
            image.Write(w);
            w.Write(name);
            w.Write(numberANDversion);
            w.Write(expression);
            w.Write(proper_body);
            w.Write(proper_mind);
            w.Write(voice);
            w.Write(range);
            w.Write(target);
            w.Write(attribute);
            w.Write(resist);
            w.Write(success);
            w.Write(visual);
            w.Write(Effects.Count);
            foreach (EffectData ef in Effects)
                ef.Write(w);
            w.Write(add_avoid);
            w.Write(add_resist);
            w.Write(add_armor);
            w.Write(wav1);
            w.Write(wav2);
            w.Write(keyCode[0]);
            w.Write(keyCode[1]);
            w.Write(keyCode[2]);
            w.Write(keyCode[3]);
            w.Write(keyCode[4]);

            if (Version >= 2)
            {
                w.Write(rarityANDfix);
            }

            if (Version > 2)
            {
                w.Write(scenarioName);
                w.Write(author);
                w.Write(Events.Count);
                foreach (EventData ev in Events)
                    ev.Write(w);
                w.Write(hold);

                if (Version == 5)
                    w.Write(makeVersion);

            }

            w.Write(levelORcount);

            if (WidID == WidIDtype.b)
            {
                if (Version == 5)
                    w.Write(hutai);
                return;
            }
            w.Write(skilluseORinitcount);
            if (WidID == WidIDtype.XL)
                return;

            w.Write(price);
            w.Write(possess_avoid);
            w.Write(possess_resist);
            w.Write(possess_armor);
        }
        
        #endregion

    }//class WidCard

}
