using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using WidReader.Data;

namespace WidReader
{
    public partial class WidReader : Form
    {
        const string title = "WidReader+ ";
        string filename = string.Empty;
        WidCard card = null;
        bool isEnabled = true;
        //\^Cv
        WidIDtype dispType = WidIDtype.XL;
        //o[W
        const uint VERSION2 = 2;
        const uint VERSION4 = 4;
        uint version = VERSION4;
        const string INDENT = "  ";

        /// <summary>
        /// RXgN^
        /// </summary>
        public WidReader()
        {
            InitializeComponent();
        }

        /// <summary>
        /// [h̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void WidReader_Load(object sender, EventArgs e)
        {
            // ŏ͕\Ȃ
            tabWidCard.Visible = false;
            this.toolSave.Enabled = false;
                
            foreach (TabPage page in this.tabWidCard.TabPages)
            {
                ControlReadOnly(page, isEnabled);
            }

            for (byte i = 0; i <= (byte)ʑ.; i++)
            {
                cmbEffectAttribute.Items.Add((ʑ)i);
            }
            this.cmbEffectAttribute.SelectedIndex = 0;

            for (byte i = 0; i <= (byte)R.K; i++)
            {
                cmbResistAttribute.Items.Add((R)i);
            }
            this.cmbResistAttribute.SelectedIndex = 0;

            for (int i = 0; i <= (int)g̓Ivf._; i++)
            {
                this.cmbPhys.Items.Add((g̓Ivf)i);
            }
            this.cmbPhys.SelectedIndex = 0;

            for (int i = 0; i <= (int)_Ivf\p.; i++)
            {
                this.cmbMind.Items.Add((_Ivf\p)i);
            }
            this.cmbMind.SelectedIndex = 0;

            for (byte i = 0; i <= (byte)ʖڕW.o; i++)
            {
                this.cmbEffectTarget.Items.Add((ʖڕW)i);
            }
            this.cmbEffectTarget.SelectedIndex = 0;

            for (byte i = 0; i <= (byte)ʔ͈.S; i++)
            {
                this.cmbEffectRange.Items.Add((ʔ͈)i);
            }
            this.cmbEffectRange.SelectedIndex = 0;

            for (byte i = 0; i <= (byte)o.nk; i++)
            {
                this.cmbViewEffect.Items.Add((o)i);
            }
            this.cmbViewEffect.SelectedIndex = 0;

            for (byte i = 0; i <= (byte)󏭓x.v~A; i++)
            {
                this.cmbCardRarity.Items.Add((󏭓x)i);
            }
            this.cmbCardRarity.SelectedIndex = 0;

            for (byte i = 0; i <= (byte)EffectData.ʃ^u.; i++)
            {
                this.cmbEffectTab.Items.Add((EffectData.ʃ^u)i);
            }

            this.cmbEffectTab.SelectedIndex = 0;


            for (byte i = 0; i <= (byte)EffectData.l̎.ől; i++)
            {
                this.cmbValueKind.Items.Add((EffectData.l̎)i);
            }
            this.cmbValueKind.SelectedIndex = 0;


            for (byte i = 0; i <= (byte)EffectData..C; i++)
            {
                this.cmbAttribute.Items.Add((EffectData.)i);
            }
            this.cmbAttribute.SelectedIndex = 0;

            string[] argv = Environment.GetCommandLineArgs();
            if (argv.Length == 2)
            {
                if (File.Exists(argv[1]))
                {
                    this.filename = argv[1];
                    OpenProcess();
                }
            }
        }

        /// <summary>
        /// ċAIɃRg[ReadOnlyɂ鏈
        /// </summary>
        /// <param name="ctrl"></param>
        /// <param name="enabled"></param>
        private void ControlReadOnly(Control ctrl, bool enabled)
        {
            foreach (Control child in ctrl.Controls)
            {
                if (child is TextBox)
                {
                    if (child.Name.StartsWith("txtEvent"))
                    {
                        //gpCxg͕KReadOnly
                        ((TextBox)child).ReadOnly = true;
                    }
                    else
                    {
                        ((TextBox)child).ReadOnly = !enabled;
                    }
                    // continueȂƃ`FbN{bNXReadOnlyɂȂ
                    continue;
                }

                if (child is ButtonBase)
                {
                    ((ButtonBase)child).Enabled = enabled;
                }

                if (child is ListControl)
                {
                    ((ListControl)child).Enabled = enabled;
                }

                if (child is CheckBox)
                {
                    ((CheckBox)child).Enabled = enabled;
                }

                if (child is UpDownBase)
                {
                    ((UpDownBase)child).ReadOnly = !enabled;
                    continue;
                }

                if (child is TrackBar)
                {
                    ((TrackBar)child).Enabled = enabled;
                }

                if (child.HasChildren)
                {
                    ControlReadOnly(child,enabled);
                }
    
            }
        }

        /// <summary>
        /// j[VK쐬NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolNew_Click(object sender, EventArgs e)
        {
            NewProcess();
        }

        /// <summary>
        /// VK쐬
        /// </summary>
        private void NewProcess()
        {
            // J[h̎ނ߂
            using (CardTypeSelect select = new CardTypeSelect())
            {
                if (select.ShowDialog() == DialogResult.OK)
                {
                    ClearProcess();

                    dispType = select.Type;

                    // lݒiVK쐬Version4ō쐬܂Bj
                    version = VERSION4;

                    card = new WidCard(dispType);
                    card.Version = version;
                    card.FileNumber = 1;
                    card.HoldCard = false;

                    EventData eve = new EventData(false);
                    ContentData cont = new ContentData();
                    cont.Kind = 0;
                    cont.Choice = "gpCxg";
                    cont.Version = version;
                    cont.Data = new BaseContent(0);
                    eve.Starts.Add(cont);

                    card.Events.Add(eve);

                    ShowProcess();
                }
            }
        }

        /// <summary>
        /// j[JNbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolOpen_Click(object sender, EventArgs e)
        {
            using (OpenFileDialog dlg = new OpenFileDialog())
            {
                dlg.CheckFileExists = true;
                dlg.InitialDirectory = @".\";
                dlg.Filter =
                    "widt@C(*.wid)|*.wid";
                dlg.FilterIndex = 0;
                dlg.Title = "Cwidt@CIĂ";

                DialogResult res = dlg.ShowDialog();
                if (res == DialogResult.OK &&
                   File.Exists(dlg.FileName))
                {
                    this.filename = dlg.FileName;
                    OpenProcess();
                }
            }
        }

        /// <summary>
        /// ǂݍݏ
        /// </summary>
        private void OpenProcess()
        {
            if (card != null)
            {
                // łɓǂݍݍ
                // ۑ悤ɂȂjmFȂǂ
                // f[^̃NA
                string file = this.filename;
                ClearProcess();
                this.filename = file;
            }

            try
            {
                string name 
                    = Path.GetFileNameWithoutExtension(filename);

                string extension 
                    = Path.GetExtension(filename);

                if (extension.Equals(".wid"))
                {
                    try
                    {
                        // tH_Environment.wyd邩ǂ`FbN
                        string yadoEnv = Path.GetDirectoryName(filename) + "\\Environment.wyd";
                        if (File.Exists(yadoEnv))
                        {
                            // h̊f[^J[hʂ擾
                            InnData inn = new InnData();
                            inn.Read(yadoEnv);

                            bool filecheck = false;
                            foreach (CardIndexData data in inn.CardIndexDatas)
                            {
                                if (data.RenamedName == name)
                                {
                                    filecheck = true;
                                    switch (data.CardKind)
                                    {
                                        case CardIndexData.Kind.skill:
                                            dispType = WidIDtype.XL;
                                            break;
                                        case CardIndexData.Kind.item:
                                            dispType = WidIDtype.ACe;
                                            break;
                                        case CardIndexData.Kind.beast:
                                            dispType = WidIDtype.b;
                                            break;
                                    }
                                    break;
                                }
                            }

                            if (!filecheck)
                            {
                                MessageBox.Show("XLACebł肢܂B");
                                ClearProcess();
                                return;
                            }

                            card = new WidCard(dispType);
                            card.Read(filename);
                            version = card.Version;

                        }
                        else
                        {
                            // t@CwɂJ[hǂݍݏ
                            card = new WidCard(filename);
                            version = card.Version;
                            dispType = card.WidID;
                        }

                        //\
                        ShowProcess();
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("XLACebł肢܂B");
                        ClearProcess();
                        return;
                    }
                }
                else
                {
                    MessageBox.Show("XLACebł肢܂B");
                    ClearProcess();
                    return;
                }
            }
            catch
            {
                MessageBox.Show("ǂݍ߂܂B");
                ClearProcess();
            }
        }

        /// <summary>
        /// \f[^NA
        /// </summary>
        private void ClearProcess()
        {
            this.listEffectData.Items.Clear();

            this.txtAuthor.Text = string.Empty;
            this.txtEvent.Text = string.Empty;
            this.txtExpression.Text = string.Empty;
            this.txtKeyCode1.Text = string.Empty;
            this.txtKeyCode2.Text = string.Empty;
            this.txtKeyCode3.Text = string.Empty;
            this.txtKeyCode4.Text = string.Empty;
            this.txtKeyCode5.Text = string.Empty;
            this.txtName.Text = string.Empty;
            this.txtScenario.Text = string.Empty;
            this.txtSoundInit.Text = string.Empty;
            this.txtSoundNext.Text = string.Empty;
            
            this.cmbAttribute.SelectedIndex = 0;
            this.cmbCardRarity.SelectedIndex = 0;
            this.cmbEffectAttribute.SelectedIndex = 0;
            this.cmbEffectRange.SelectedIndex = 0;
            this.cmbEffectTab.SelectedIndex = 0;
            this.cmbEffectTabSub.SelectedIndex = 0;
            this.cmbEffectTarget.SelectedIndex = 0;
            this.cmbMind.SelectedIndex = 0;
            this.cmbPhys.SelectedIndex = 0;
            this.cmbResistAttribute.SelectedIndex = 0;
            this.cmbValueKind.SelectedIndex = 0;
            this.cmbViewEffect.SelectedIndex = 0;

            this.trackSuccessChange.Value = 0;
            this.trackUseAvoid.Value = 0;
            this.trackUseDefend.Value = 0;
            this.trackUseResist.Value = 0;

            this.numCost.Value = 0;
            this.numFileNo.Value = 1;
            this.numLVCount.Value = 0;
            this.numPosessAvoid.Value = 0;
            this.numPosessDefend.Value = 0;
            this.numPosessResist.Value = 0;
            this.numRound.Value = 1;
            this.numValue.Value = 1;

            this.Text = title;

            card = null;
            tabWidCard.Visible = false;

            this.toolSave.Enabled = false;

            this.filename = string.Empty;


            // b͏bo邩oȂWidIDTypeɂĈႤ
            this.cmbEffectTab.Items.Clear();
            for (byte i = 0; i <= (byte)EffectData.ʃ^u.; i++)
            {
                this.cmbEffectTab.Items.Add((EffectData.ʃ^u)i);
            }
            this.cmbEffectTab.SelectedIndex = 0;

        }

        /// <summary>
        /// \
        /// </summary>
        private void ShowProcess()
        {
            //ʏ
            this.Text = title + card.WidID.ToString() + " ver." + version + " " + this.filename;

            // O
            this.txtName.Text = card.CardName;
            // t@CNo
            this.numFileNo.Value = card.FileNumber;
            
            // 
            this.txtExpression.Text = card.Expression;
            // C[W
            this.picImage.Image = card.Image.bitmap;

            // 쐬ViI
            this.txtScenario.Text = card.ScenarioName;

            // Җ
            this.txtAuthor.Text = card.AuthorName;

            // v
            this.chkSilent.Checked = card.NeedCast;

            // 
            this.cmbEffectAttribute.SelectedIndex = (int)card.EffectAttribute;
            this.cmbResistAttribute.SelectedIndex = (int)card.ResistAttribute;

            // gp@\͒lCib͏Lj
            this.trackUseAvoid.Value = card.AvoidModifyUsing;
            this.trackUseResist.Value = card.ResistModifyUsing;
            this.trackUseDefend.Value = card.ArmorModifyUsing;

            // vf
            this.cmbPhys.SelectedIndex = (int)card.BodyFacter;
            int mindfactor = (int)card.MindFacter;
            this.cmbMind.SelectedIndex = ChangeDispMindFactor(mindfactor);

            // 
            this.cmbEffectTarget.SelectedIndex = (int)card.Target;
            this.cmbEffectRange.SelectedIndex = (int)card.Range;
            this.cmbViewEffect.SelectedIndex = (int)card.VisualEffect;

            if (version >= VERSION2)
            {
                grpRarity.Visible = true;
                this.cmbCardRarity.SelectedIndex = (int)card.Rarity;
            }
            else
            {
                grpRarity.Visible = false;
            }

            this.trackSuccessChange.Value = card.SuccessRate;

            this.txtSoundInit.Text = this.card.SoundOnUsing;
            this.txtSoundNext.Text = this.card.SoundOnEffect;
            this.txtKeyCode1.Text = this.card.KeyCode[0];
            this.txtKeyCode2.Text = this.card.KeyCode[1];
            this.txtKeyCode3.Text = this.card.KeyCode[2];
            this.txtKeyCode4.Text = this.card.KeyCode[3];
            this.txtKeyCode5.Text = this.card.KeyCode[4];

            // ʃf[^
            ShowEffectData();

            // J[hʂ
            switch (dispType)
            {
                case WidIDtype.XL:
                    grpUseFix.Text = "gp \͒lC";
                    grpLVCount.Text = "Z\x";
                    this.numLVCount.Value = card.Level;
                    this.grpCost.Visible = false;
                    this.grpPosessFix.Visible = false;
                    break;
                case WidIDtype.ACe:
                    grpUseFix.Text = "gp \͒lC";
                    grpLVCount.Text = "gp\";
                    this.numLVCount.Value = card.ItemInitialUseCount;

                    // i
                    this.numCost.Value = card.ItemPrice;
                    this.grpCost.Visible = true;

                    // L@\͒lC
                    this.numPosessAvoid.Value = card.PossessModifyAvoid;
                    this.numPosessResist.Value = card.PossessModifyResist;
                    this.numPosessDefend.Value = card.PossessModifyArmor;
                    this.grpPosessFix.Visible = true;

                    break;
                case WidIDtype.b:
                    grpUseFix.Text = "L \͒lC";
                    grpLVCount.Text = "gp";
                    this.numLVCount.Value = card.ItemRemainUseCount;

                    this.grpCost.Visible = false;

                    this.grpPosessFix.Visible = false;

                    // b͏boȂ̂
                    this.cmbEffectTab.Items.Clear();
                    for (byte i = 0; i < (byte)EffectData.ʃ^u.; i++)
                    {
                        this.cmbEffectTab.Items.Add((EffectData.ʃ^u)i);
                    }

                    this.cmbEffectTab.SelectedIndex = 0;
                    break;
            }

            // gpCxg
            int index = 0;
            foreach (EventData data in this.card.Events)
            {
                this.txtEvent.Text += "Cxg " + (++index) + Environment.NewLine;
                foreach (string key in data.KeyCodes)
                {
                    this.txtEvent.Text += "L[R[hF" + key + Environment.NewLine;
                }

                foreach(ContentData start in data.Starts)
                {
                    DispContentText(this.txtEvent, start, 1);
                }
            }

            // \
            tabWidCard.Visible = true;
            // h̃t@C`̏ꍇ̓Z[uȂ
            toolSave.Enabled = !card.FixCardType;
        }

        /// <summary>
        /// ʃf[^\
        /// </summary>
        private void ShowEffectData()
        {
            #region ʃf[^
            this.listEffectData.Items.Clear();

            foreach (EffectData effect in this.card.Effects)
            {
                string listItem = string.Empty;

                listItem += effect.EffectTab.ToString() + " ";

                switch (effect.EffectTab)
                {
                    case EffectData.ʃ^u.:
                        listItem +=
                        ((EffectData.)effect.EffectNumberInTab).ToString()
                        + " ";

                        listItem +=
                        ((EffectData.l̎)effect.ValueKind).ToString()
                        + " " + effect.Value.ToString();

                        break;
                    case EffectData.ʃ^u.:
                        listItem +=
                        ((EffectData.)effect.EffectNumberInTab).ToString()
                        + " ";

                        listItem +=
                        ((EffectData.l̎)effect.ValueKind).ToString()
                        + " " + effect.Value.ToString();

                        break;
                    case EffectData.ʃ^u.Z\:
                        listItem +=
                        ((EffectData.Z\)effect.EffectNumberInTab).ToString();
                        break;
                    case EffectData.ʃ^u._:
                        listItem +=
                        ((EffectData._)effect.EffectNumberInTab).ToString()
                        + " ";

                        if (version > VERSION2)
                        {
                            listItem +=
                            effect.Round.ToString()
                            + "Eh";
                        }
                        break;
                    case EffectData.ʃ^u.@:
                        listItem +=
                        ((EffectData.@)effect.EffectNumberInTab).ToString()
                        + " ";

                        if (version > VERSION2)
                        {
                            listItem +=
                            effect.Round.ToString()
                            + "Eh";
                        }
                        break;
                    case EffectData.ʃ^u.\:
                        listItem +=
                        ((EffectData.\)effect.EffectNumberInTab).ToString()
                        + " ";

                        listItem +=
                        effect.MagicValue.ToString()
                        + " ";

                        if (version > VERSION2)
                        {
                            listItem +=
                            effect.Round.ToString()
                            + "Eh";
                        }
                        break;
                    case EffectData.ʃ^u.:
                        listItem +=
                        ((EffectData.)effect.EffectNumberInTab).ToString();
                        break;
                    case EffectData.ʃ^u.J[h:
                        listItem +=
                        ((EffectData.J[h)effect.EffectNumberInTab).ToString();
                        break;
                    case EffectData.ʃ^u.:
                        listItem +=
                        ((EffectData.)effect.EffectNumberInTab).ToString()
                        + " ";

                        listItem += effect.Beast.CardName;


                        break;
                }

                listItem += " ";
                listItem += effect.Attribute.ToString();

                this.listEffectData.Items.Add(listItem);
            }
            #endregion
        }

        /// <summary>
        /// Reg̃eLXg\
        /// </summary>
        /// <param name="text"></param>
        /// <param name="data"></param>
        /// <param name="indent"></param>
        private void DispContentText(TextBox text, ContentData data,int indent)
        {
            // RegʁEI
            text.Text = AddIndentText(text.Text, indent,
                ((Reg)data.Kind).ToString() + 
                " (" + data.Choice + ")" );

            // f[^ij
            BaseContent cont = data.Data;

            switch (data.Kind)
            {
                // ^
                case 0x01:  // X^[gNReg (terminal)
                    text.Text = AddIndentText(text.Text, indent,
                        "N:" + cont.StringData);
                    break;
                case 0x07:  // aflReg (standard)
                    text.Text = AddIndentText(text.Text, indent,
                        "afl:" + cont.StringData);
                    break;
                case 0x09:  // ʉReg (standard)
                    text.Text = AddIndentText(text.Text, indent,
                        "ʉ:" + cont.StringData);
                    break;
                case 0x0f:  // tOReg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "tO:" + cont.StringData);
                    break;
                case 0x11:  // Xebv򕪊Reg (data)
                case 0x29:  // XebvReg (data)
                case 0x2a:  // XebvReg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "Xebv:" + cont.StringData);
                    break;
                case 0x2b:  // tO]Reg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "tO:" + cont.StringData);
                    break;
                case 0x34:  // X^[gR[Reg (standard)
                    text.Text = AddIndentText(text.Text, indent,
                        "R[:" + cont.StringData);
                    break;
                case 0x39:  // I󕪊Reg (brunch)
                case 0x3a:  // ItReg (get)
                case 0x3b:  // I폜Reg (lost)
                    text.Text = AddIndentText(text.Text, indent,
                        "ViI:" + cont.StringData);
                    break;
                case 0x3c:  // SVbvReg (brunch)
                case 0x3d:  // SVbvǉReg (get)
                case 0x3e:  // SVbv폜Reg (lost)
                    text.Text = AddIndentText(text.Text, indent,
                        "SVbv:" + cont.StringData);
                    break;
                case 0x41:  // tOReg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "tO:" + cont.StringData);
                    break;

                // {Sa^
                case 0x2c:  // Xebv㉺Reg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "Xebv:" + cont.StringData);
                    text.Text = AddIndentText(text.Text, indent,
                        "l:" + cont.UInt);
                    break;
                case 0x12:  // XebvύXReg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "Xebv:" + cont.StringData);
                    text.Text = AddIndentText(text.Text, indent,
                        "ύXl:" + cont.UInt);
                    break;

                // {Sa{Pa^
                case 0x20:  // N[|擾Reg (get)
                    text.Text = AddIndentText(text.Text, indent,
                        "N[|:" + cont.StringData);
                    text.Text = AddIndentText(text.Text, indent,
                        "_:" + cont.Int2);
                    text.Text = AddIndentText(text.Text, indent,
                        "Kp͈:" + (Ώ)cont.Byte1);
                    break;
                case 0x27:  // N[|rReg (lost)
                    text.Text = AddIndentText(text.Text, indent,
                        "N[|:" + cont.StringData);
                    ////text.Text = AddIndentText(text.Text, indent,
                    ////    "_:" + cont.Int2);
                    text.Text = AddIndentText(text.Text, indent,
                        "Kp͈:" + (Ώ)cont.Byte1);
                    break;
                case 0x19:  // N[|Reg (brunch)
                    text.Text = AddIndentText(text.Text, indent,
                        "N[|:" + cont.StringData);
                    ////text.Text = AddIndentText(text.Text, indent,
                    ////    "_:" + cont.Int2);
                    text.Text = AddIndentText(text.Text, indent,
                        "Kp͈:" + (Ώ)cont.Byte1);
                    break;

                // {Pa^
                case 0x10:  // tOύXReg (data)
                    text.Text = AddIndentText(text.Text, indent,
                        "tO:" + cont.StringData);
                    text.Text = AddIndentText(text.Text, indent,
                        "ύXl:" + cont.Byte1);
                    break;

                // Sa^
                case 0x0a:  // 󔒎ԃReg (standard)
                    text.Text = AddIndentText(text.Text, indent,
                        "0.1s * " + cont.UInt);
                    break;
                case 0x36:  // pbP[WR[Reg (standard)
                case 0x02:  // ogReg (terminal)
                case 0x05:  // GAړReg (terminal)
                case 0x35:  // pbP[WNReg (terminal)
                case 0x1a:  // LXgReg (get)
                case 0x21:  // LXgEReg (lost)
                case 0x13:  // LXgݕReg (brunch)
                case 0x1d:  // Reg (get)
                case 0x24:  // rReg (lost)
                case 0x16:  // 񕪊Reg (brunch)
                    text.Text = AddIndentText(text.Text, indent,
                        "ID:" + cont.UInt);
                    break;

                case 0x1f:  // Reg (get)
                    text.Text = AddIndentText(text.Text, indent,
                        "z:" + cont.UInt);
                    break;
                case 0x26:  // Reg (lost)
                    text.Text = AddIndentText(text.Text, indent,
                        "z:" + cont.UInt);
                    break;
                case 0x18:  // Reg (brunch)
                    text.Text = AddIndentText(text.Text, indent,
                        "z:" + cont.UInt);
                    break;
                case 0x0e:  // _Reg (utility)
                    text.Text = AddIndentText(text.Text, indent,
                        ":" + cont.UInt);
                    break;
                case 0x30:  // lReg (utility)
                    text.Text = AddIndentText(text.Text, indent,
                        "l:" + cont.UInt);
                    break;

                // Sa{Sa{Pa^
                case 0x1b:  // ACeReg (get)
                case 0x22:  // ACerReg (lost)
                case 0x14:  // ACeReg (brunch)
                case 0x1c:  // Z\Reg (get)
                case 0x23:  // Z\rReg (lost)
                case 0x15:  // Z\Reg (brunch)
                case 0x1e:  // bReg (get)
                case 0x25:  // brReg (lost)
                case 0x17:  // bReg (brunch)
                    text.Text = AddIndentText(text.Text, indent,
                        "ID:" + cont.UInt);
                    text.Text = AddIndentText(text.Text, indent,
                        ":" + cont.Int2);
                    text.Text = AddIndentText(text.Text, indent,
                        "Kp͈:" + (J[hKp͈)cont.Byte1);
                    break;

                // Pa^
                case 0x03:  // IReg (terminal)
                    text.Text = AddIndentText(text.Text, indent,
                        "NA:" + (ViII)cont.Byte1);
                    break;

                // Pa{Pa^
                case 0x0c:  // oIReg (utility)
                    text.Text = AddIndentText(text.Text, indent,
                        "IΏ:" + (oIΏ)cont.Byte1);
                    text.Text = AddIndentText(text.Text, indent,
                        "I@:" + (oI@)cont.Byte2);
                    break;
                case 0x2f:  // ԔReg (utility)
                    text.Text = AddIndentText(text.Text, indent,
                        "Ώ:" + (Ώ)cont.Byte2);
                    text.Text = AddIndentText(text.Text, indent,
                        ":" + (ԕ򔻒)cont.Byte1);
                    break;

                // Pa{Sa^
                case 0x2e:  // xReg (utility)
                    text.Text = AddIndentText(text.Text, indent,
                        "oĨxΏ:" + (oĨxΏ)cont.Byte1);
                    text.Text = AddIndentText(text.Text, indent,
                        "背x:" + cont.UInt);
                    break;

                // f[^Ȃ^
                case 0x00:  // X^[gReg (terminal)
                case 0x33:  // ʒfReg (terminal)
                case 0x2d:  // ^[o߃Reg (standard)
                case 0x04:  // Q[I[o[Reg (terminal)
                case 0x31:  // p[eB[\Reg (visual)
                case 0x32:  // p[eB[BReg (visual)
                case 0x40:  // ʍč\zReg (visual)
                case 0x37:  // GAReg (utility)
                case 0x38:  // ogReg (utility)
                case 0x3F:  // ogReg (utility)
                    break;

                // ̑^
                case 0x0d:  //\͔Reg (utility)
                    AbilityCheckContent abicheck = (AbilityCheckContent)cont;
                    text.Text = AddIndentText(text.Text, indent,
                        "x:" + abicheck.Level.ToString() + " " +
                        "g:" + abicheck.BodyFactor.ToString() + " " +
                        "_:" + abicheck.MindFactor.ToString() + " " +
                        ":" + (abicheck.SleeperFailer ? "" : "L") + " " +
                        "Ώ:" + abicheck.Target.ToString());
                    break;
                case 0x08:  // wiύXReg (standard)
                    ViewChangeContent vcCont = (ViewChangeContent)cont;
                    foreach (CellData cell in vcCont.Cells)
                    {
                        //Z摜̃t@C
                        text.Text = AddIndentText(text.Text, indent,
                            "摜t@C:" + cell.FileName);
                        text.Text = AddIndentText(text.Text, indent,
                            "x,y,width,height:" +
                            cell.Left + "," +
                            cell.Top + "," +
                            cell.Width + "," +
                            cell.Height);
                        text.Text = AddIndentText(text.Text, indent,
                            "o[W,}XNL,QƃtO:" +
                            cell.Version + "," +
                            (cell.MaskOn ? "L" : "") + "," +
                            cell.FlagName);
                    }
                    break;
                case 0x0b:  // ʃReg
                    EffectContent effectCont = (EffectContent)cont;
                    text.Text = AddIndentText(text.Text, indent,
                        "Ώۃx:" + effectCont.Level.ToString() + " " +
                        "ʑ:" + effectCont.EffectAttribute.ToString() + " " +
                        "o:" + effectCont.VisualEffect.ToString() + " " +
                        "R:" + effectCont.ResistAttribute.ToString() + " " +
                        "Ώ:" + effectCont.Target.ToString());
                    text.Text = AddIndentText(text.Text, indent,
                        "ʉ:" + effectCont.SoundFile + " " +
                        "Cl:" + effectCont.SuccessRate);
                    foreach (EffectData effect in effectCont.Effects)
                    {
                        text.Text = PlusIndentText(text.Text, indent, "");
                        text.Text += effect.Attribute.ToString() + " " +
                            effect.EffectTab.ToString() + " ";

                        string listItem = "";
                        switch (effect.EffectTab)
                        {
                            case EffectData.ʃ^u.:
                                listItem +=
                                ((EffectData.)effect.EffectNumberInTab).ToString()
                                + " ";

                                listItem +=
                                ((EffectData.l̎)effect.ValueKind).ToString()
                                + " " + effect.Value.ToString();

                                break;
                            case EffectData.ʃ^u.:
                                listItem +=
                                ((EffectData.)effect.EffectNumberInTab).ToString()
                                + " ";

                                listItem +=
                                ((EffectData.l̎)effect.ValueKind).ToString()
                                + " " + effect.Value.ToString();

                                break;
                            case EffectData.ʃ^u.Z\:
                                listItem +=
                                ((EffectData.Z\)effect.EffectNumberInTab).ToString();
                                break;
                            case EffectData.ʃ^u._:
                                listItem +=
                                ((EffectData._)effect.EffectNumberInTab).ToString()
                                + " ";

                                listItem +=
                                effect.Round.ToString()
                                + "Eh";
                                break;
                            case EffectData.ʃ^u.@:
                                listItem +=
                                ((EffectData.@)effect.EffectNumberInTab).ToString()
                                + " ";

                                listItem +=
                                effect.Round.ToString()
                                + "Eh";
                                break;
                            case EffectData.ʃ^u.\:
                                listItem +=
                                ((EffectData.\)effect.EffectNumberInTab).ToString()
                                + " ";

                                listItem +=
                                effect.MagicValue.ToString()
                                + " ";

                                listItem +=
                                effect.Round.ToString()
                                + "Eh";
                                break;
                            case EffectData.ʃ^u.:
                                listItem +=
                                ((EffectData.)effect.EffectNumberInTab).ToString();
                                break;
                            case EffectData.ʃ^u.J[h:
                                listItem +=
                                ((EffectData.J[h)effect.EffectNumberInTab).ToString();
                                break;
                            case EffectData.ʃ^u.:
                                listItem +=
                                ((EffectData.)effect.EffectNumberInTab).ToString()
                                + " ";

                                listItem += effect.Beast.CardName;


                                break;
                        }

                        listItem += " ";
                        text.Text += listItem;

                        text.Text += Environment.NewLine;
                    }

                    break;
                case 0x28:  // ZtReg
                    SerifContent serifCont = (SerifContent)cont;
                    //b
                    text.Text = AddIndentText(text.Text, indent,
                        "b:" + serifCont.Speaker.ToString());
                    //䎌f[^
                    foreach (SerifData serif in serifCont.SerifDatas)
                    {
                        text.Text = PlusIndentText(text.Text, indent,
                            "N[|:");
                        bool first = true;
                        foreach (string coup in serif.Coupons)
                        {
                            text.Text += coup;
                            if (first == false)
                            {
                                text.Text += ",";
                            }
                            else
                            {
                                first = false;
                            }
                        }
                        text.Text += Environment.NewLine;
                        text.Text = AddIndentText(text.Text, indent,
                        "{:" + serif.Message);
                    }
                    break;
                case 0x06:  // bZ[WReg
                    MessageContent mes = (MessageContent)cont;
                    string speaker = mes.Speaker;
                    if (speaker == MessageContent.Random)
                    {
                        speaker = "_";
                    }
                    else if (speaker == MessageContent.Select)
                    {
                        speaker = "I𒆃o";
                    }
                    else if (speaker == MessageContent.Unselect)
                    {
                        speaker = "I𒆈ȊO";
                    }
                    else if (speaker == MessageContent.Card)
                    {
                        speaker = "gpJ[h";
                    }

                    text.Text = AddIndentText(text.Text, indent,
                        "b:" + speaker);
                    text.Text = AddIndentText(text.Text, indent,
                        "{:" + mes.Message);
                    break;
            }


            foreach(ContentData child in data.Children)
            {
                // qReg
                DispContentText(text, child, indent + 1);
            }
        }

        private string AddIndentText(string str, int indent, string addText)
        {
            for (int i = 0; i < indent; i++)
                str += INDENT;
            str += addText + Environment.NewLine;
            return str;
        }

        private string PlusIndentText(string str, int indent, string addText)
        {
            for (int i = 0; i < indent; i++)
                str += INDENT;
            str += addText;
            return str;
        }
        /// <summary>
        /// _IvfiSelectedIndexɑΉj̐lɕϊ
        /// </summary>
        /// <param name="mindFactor"></param>
        /// <returns></returns>
        private int ChangeDispMindFactor(int mindFactor)
        {
            int abs = (mindFactor < 0) ? - mindFactor : mindFactor;
            return (abs - 1) * 2 + ((mindFactor < 0) ? 1 : 0); 
        }

        /// <summary>
        /// ̐l_IvfEnumɕϊ
        /// </summary>
        /// <param name="selectedDispMindFactor"></param>
        /// <returns></returns>
        private _Ivf ChangeMindFactor(int selectedDispMindFactor)
        {
            bool plus = selectedDispMindFactor % 2 == 0;
            return (_Ivf)((selectedDispMindFactor / 2 + 1) * (plus ? 1 : -1));
        }

        /// <summary>
        /// j[ۑ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolSave_Click(object sender, EventArgs e)
        {
            SaveProcess();
        }

        /// <summary>
        /// ۑ
        /// </summary>
        private void SaveProcess()
        {
            if (card != null)
            {

                // O
                if (string.IsNullOrEmpty(this.txtName.Text))
                {
                    MessageBox.Show("J[h͂Ă܂B");
                    this.tabCard.Focus();
                    this.txtName.Focus();
                    return;
                }
                card.CardName = this.txtName.Text;

                card.FileNumber = (uint)this.numFileNo.Value;

                string baseFile = string.Empty;
                switch (card.WidID)
                {
                    case WidIDtype.XL:
                        baseFile = "Skill" + card.FileNumber + ".wid";
                        break;
                    case WidIDtype.ACe:
                        baseFile = "Item" + card.FileNumber + ".wid";
                        break;
                    case WidIDtype.b:
                        baseFile = "Beast" + card.FileNumber + ".wid";
                        break;

                }

                // t@C
                bool changed = string.IsNullOrEmpty(this.filename);
                string previous = string.Empty;


                if (changed)
                {
                    using (SaveFileDialog dlg = new SaveFileDialog())
                    {
                        dlg.FileName = baseFile;
                        dlg.InitialDirectory = @".\";
                        dlg.Filter =
                            "widt@C(*.wid)|*.wid";
                        dlg.FilterIndex = 0;
                        dlg.Title = "ۑ̃t@CIĂ";

                        if (dlg.ShowDialog() == DialogResult.OK)
                        {
                            this.filename = dlg.FileName;
                            card.FullPath = this.filename;
                        }
                        else
                        {
                            return;
                        }
                    }
                }
                else
                {
                    if (!baseFile.Equals(Path.GetFileName(this.filename)))
                    {
                        // FileNoςĂ̂Ńt@CςقǂȂH
                        if (MessageBox.Show("t@C " + baseFile + " ɕύX܂H",
                            "ύXmF",
                            MessageBoxButtons.YesNo,
                            MessageBoxIcon.Question) == DialogResult.Yes)
                        {
                            previous = this.filename;

                            this.filename =
                                Path.GetDirectoryName(this.filename) + "\\"
                                + baseFile;
                            card.FullPath = this.filename;
                        }
                    }
                }


                // 
                card.Expression = this.txtExpression.Text;

                // C[W͓Ă̂ł̂܂

                // 쐬ViI
                card.ScenarioName = this.txtScenario.Text;
                // Җ
                card.AuthorName = this.txtAuthor.Text;

                // v
                card.NeedCast = this.chkSilent.Checked;

                // 
                card.EffectAttribute = (ʑ)this.cmbEffectAttribute.SelectedIndex;
                card.ResistAttribute = (R)this.cmbResistAttribute.SelectedIndex;

                // gp@\͒lCib͏Lj
                card.AvoidModifyUsing = this.trackUseAvoid.Value;
                card.ResistModifyUsing = this.trackUseResist.Value;
                card.ArmorModifyUsing = this.trackUseDefend.Value;

                // vf
                card.BodyFacter = (g̓Ivf)this.cmbPhys.SelectedIndex;
                card.MindFacter = this.ChangeMindFactor(this.cmbMind.SelectedIndex);

                // 
                card.Target = (ʖڕW)this.cmbEffectTarget.SelectedIndex;
                card.Range = (ʔ͈)this.cmbEffectRange.SelectedIndex;
                card.VisualEffect = (o)this.cmbViewEffect.SelectedIndex;

                //Version2O̓f[^Ȃ
                card.Rarity = (󏭓x)this.cmbCardRarity.SelectedIndex;

                card.SuccessRate = this.trackSuccessChange.Value;

                // ʉ
                if (string.IsNullOrEmpty(this.txtSoundInit.Text) || this.txtSoundInit.Text.Trim() == string.Empty)
                {
                    this.txtSoundInit.Text = "iȂj";
                }
                this.card.SoundOnUsing = this.txtSoundInit.Text;
                if (string.IsNullOrEmpty(this.txtSoundNext.Text) || this.txtSoundNext.Text.Trim() == string.Empty)
                {
                    this.txtSoundNext.Text = "iȂj";
                }
                this.card.SoundOnEffect = this.txtSoundNext.Text;

                // Cxg΃L[R[h
                card.KeyCode[0] = string.IsNullOrEmpty(this.txtKeyCode1.Text)
                    ? null : this.txtKeyCode1.Text;
                card.KeyCode[1] = string.IsNullOrEmpty(this.txtKeyCode2.Text)
                    ? null : this.txtKeyCode2.Text;
                card.KeyCode[2] = string.IsNullOrEmpty(this.txtKeyCode3.Text)
                    ? null : this.txtKeyCode3.Text;
                card.KeyCode[3] = string.IsNullOrEmpty(this.txtKeyCode4.Text)
                    ? null : this.txtKeyCode4.Text;
                card.KeyCode[4] = string.IsNullOrEmpty(this.txtKeyCode5.Text)
                    ? null : this.txtKeyCode5.Text;

                // J[hʂ
                switch (card.WidID)
                {
                    case WidIDtype.XL:
                        // Z\x
                        card.Level = (uint)this.numLVCount.Value;
                        break;
                    case WidIDtype.ACe:
                        card.ItemRemainUseCount = (uint)this.numLVCount.Value;
                        card.ItemInitialUseCount = (uint)this.numLVCount.Value;

                        // i
                        card.ItemPrice = (uint)this.numCost.Value;

                        // L@\͒lC
                        card.PossessModifyAvoid = (int)this.numPosessAvoid.Value;
                        card.PossessModifyResist = (int)this.numPosessResist.Value;
                        card.PossessModifyArmor = (int)this.numPosessDefend.Value;

                        break;
                    case WidIDtype.b:
                        card.ItemRemainUseCount = (uint)this.numLVCount.Value;
                        break;
                }

                //ʃf[^͓Ă̂ł̂܂

                card.Write();

                if (!string.IsNullOrEmpty(previous))
                {
                    // t@CύXĂ
                    // ̃t@Cꍇ폜
                    File.Delete(previous);
                }

                this.Text = title + card.WidID.ToString() + " ver." + version + " " + this.filename;
            }
        }

        /// <summary>
        /// j[I
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolEnd_Click(object sender, EventArgs e)
        {
            ExitProcess();
        }

        /// <summary>
        /// I
        /// </summary>
        private void ExitProcess()
        {
            ////if (card != null)
            ////{
            ////    // t@Cǂݍݍ
            ////    MessageBox.Show("ۑɏIĂ낵łH", "mF"
            ////        , MessageBoxButtons.YesNoCancel);

            ////}

            filename = null;
            card = null;
            this.Close();
        }

        /// <summary>
        /// hbOG^[Cxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void WidReader_DragEnter(object sender, DragEventArgs e)
        {
            //hbOĂf[^ DataFormats.FileDrop ׁA
            //ł΃hbvʂAllɂ
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.All;
        }

        /// <summary>
        /// hbOhbvCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void WidReader_DragDrop(object sender, DragEventArgs e)
        {
            //hbvꂽf[^string^ׂ
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                // Ώ
                string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
                if (files.Length == 1 && File.Exists(files[0]))
                {
                    this.filename = files[0];
                    OpenProcess();
                }
            }
        }

        /// <summary>
        /// lRg[tH[JX[uCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void num_Leave(object sender, EventArgs e)
        {
            NumericUpDown updown = (NumericUpDown)sender;

            //ƂlĂȂiƂ\ĂȂjꍇ
            // złȂ̂Ŗ
        }

        /// <summary>
        /// ʃ^uIύXCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cmbEffectTab_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbEffectTab.SelectedIndex >= 0)
            {
                this.cmbEffectTabSub.Items.Clear();

                switch (this.cmbEffectTab.SelectedIndex)
                {
                    case 0:
                        for (byte i = 0; i <= (byte)EffectData..z; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = true;
                        this.grpValue.Visible = true;
                        this.grpRound.Visible = false;
                        break;
                    case 1:
                        for (byte i = 0; i <= (byte)EffectData..ŉ; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = true;
                        this.grpValue.Visible = true;
                        this.grpRound.Visible = false;
                        break;
                    case 2:
                        for (byte i = 0; i <= (byte)EffectData.Z\._͑r; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.Z\)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = false;
                        this.grpRound.Visible = false;
                        break;
                    case 3:
                        for (byte i = 0; i <= (byte)EffectData._.; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData._)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = false;
                        this.grpRound.Visible = (version > VERSION2);
                        break;
                    case 4:
                        for (byte i = 0; i <= (byte)EffectData.@.; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.@)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = false;
                        this.grpRound.Visible = (version > VERSION2);
                        break;
                    case 5:
                        for (byte i = 0; i <= (byte)EffectData.\.R͕ω; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.\)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = true;
                        this.grpRound.Visible = (version > VERSION2);
                        break;
                    case 6:
                        for (byte i = 0; i <= (byte)EffectData..b; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = false;
                        this.grpRound.Visible = false;
                        break;
                    case 7:
                        for (byte i = 0; i <= (byte)EffectData.J[h.Z\; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.J[h)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = false;
                        this.grpRound.Visible = false;
                        break;
                    case 8:
                        for (byte i = 0; i <= (byte)EffectData..b; i++)
                        {
                            this.cmbEffectTabSub.Items.Add((EffectData.)i);
                        }
                        this.cmbEffectTabSub.SelectedIndex = 0;
                        this.grpValueKind.Visible = false;
                        this.grpValue.Visible = false;
                        this.grpRound.Visible = false;
                        break;
                }
            }
        }

        /// <summary>
        /// ʒǉ{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEffectAdd_Click(object sender, EventArgs e)
        {
            EffectData data = new EffectData(version);
            data.Nazo1 = 8;
            data.Version = version;
            data.EffectTab = (EffectData.ʃ^u)this.cmbEffectTab.SelectedIndex;
            switch (data.EffectTab)
            {
                                    
                case EffectData.ʃ^u.:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;
                    data.ValueKind
                     = (EffectData.l̎)this.cmbValueKind.SelectedIndex;
                    data.Value
                     = (uint)this.numValue.Value;
                    break;
                case EffectData.ʃ^u.:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;
                    data.ValueKind
                     = (EffectData.l̎)this.cmbValueKind.SelectedIndex;
                    data.Value
                     = (uint)this.numValue.Value;
                    break;
                case EffectData.ʃ^u.Z\:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;
                    break;
                case EffectData.ʃ^u._:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;

                    if (version > VERSION2)
                    {
                        data.Round
                         = (uint)this.numRound.Value;
                    }

                    break;

                case EffectData.ʃ^u.@:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;

                    if (version > VERSION2)
                    {
                        data.Round
                         = (uint)this.numRound.Value;
                    }

                    break;
                case EffectData.ʃ^u.\:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;

                    data.MagicValue
                     = (int)this.numValue.Value;

                    if (version > VERSION2)
                    {
                        data.Round
                         = (uint)this.numRound.Value;
                    }

                    break;

                case EffectData.ʃ^u.:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;
                    break;
                case EffectData.ʃ^u.J[h:
                    data.EffectNumberInTab
                     = (byte)this.cmbEffectTabSub.SelectedIndex;
                    break;
                case EffectData.ʃ^u.:
                    using (OpenFileDialog dlg = new OpenFileDialog())
                    {
                        dlg.InitialDirectory = @".\";
                        dlg.Filter =
                            "widt@C(*.wid)|*.wid";
                        dlg.FilterIndex = 0;
                        dlg.Title = "bt@CIĂ";

                        DialogResult res = dlg.ShowDialog();
                        if (res == DialogResult.OK)
                        {
                            if (File.Exists(dlg.FileName))
                            {
                                try
                                {
                                    WidCard beast = new WidCard(dlg.FileName);
                                    if (beast.WidID != WidIDtype.b)
                                    {
                                        MessageBox.Show("bt@Cł͂܂B");
                                        data = null;
                                        return;
                                    }

                                    data.Beast = beast;
                                }
                                catch
                                {
                                    MessageBox.Show("bt@Cǂݍ߂܂łB");
                                    data = null;
                                    return;
                                }
                            }
                            else
                            {
                                // t@C݂܂B
                                MessageBox.Show("t@C݂܂B");
                                data = null;
                                return;
                            }
                        }
                        else
                        {
                            // LZ
                            data = null;
                            return;
                        }
                    }

                    break;
                
            }

            data.Attribute
                = (EffectData.)this.cmbAttribute.SelectedIndex;

            card.Effects.Add(data);

            ShowEffectData();
        }

        /// <summary>
        /// ʍ폜{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEffectDelete_Click(object sender, EventArgs e)
        {
            int index = this.listEffectData.SelectedIndex;
            if (index >= 0)
            {
                card.Effects.RemoveAt(index);
                this.listEffectData.Items.RemoveAt(index);
            }
        }

        /// <summary>
        /// rbg}bvǂݍ݃NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnRead_Click(object sender, EventArgs e)
        {
            using (OpenFileDialog dlg = new OpenFileDialog())
            {
                dlg.FileName = "default.bmp";

                dlg.InitialDirectory = @".\";

                dlg.Filter =
                    "rbg}bvt@C(*.bmp)|*.bmp";
                dlg.FilterIndex = 0;
                dlg.Title = "ǂݍރrbg}bvt@CIĂ";

                if (dlg.ShowDialog() == DialogResult.OK)
                {
                    try
                    {
                        Bitmap bmp = new Bitmap(dlg.FileName);
                        ImageData img = new ImageData(bmp);
                        
                        picImage.Image = img.bitmap;
                        card.Image = img;
                    }
                    catch (Exception)
                    {
                        MessageBox.Show("C[Wǂݍ߂܂B");
                        picImage.Image = card.Image.bitmap;
                    }
                }
            }
        }

        /// <summary>
        /// rbg}bv荞ݕۑ{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSave_Click(object sender, EventArgs e)
        {
            if(card.Image.baseBitmap != null){
                using (SaveFileDialog dlg = new SaveFileDialog())
                {
                    dlg.FileName = "new.bmp";
                    dlg.InitialDirectory = @".\";
                    dlg.Filter =
                        "rbg}bvt@C(*.bmp)|*.bmp";
                    dlg.FilterIndex = 0;
                    dlg.Title = "ۑ̃t@CIĂ";

                    if (dlg.ShowDialog() == DialogResult.OK)
                    {
                        card.Image.baseBitmap.Save(dlg.FileName);
                    }
                }
            }
        }
        
        /// <summary>
        /// rbg}bvNA{^NbN
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClear_Click(object sender, EventArgs e)
        {
            card.Image = new ImageData();
            picImage.Image = null;
        }

    }
}